#include <bits/stdc++.h>
using namespace std;

const int maxn = 200005;
int n, q;
map <int, int> drinks [maxn];
int cnt_drinks [maxn];
int tree [4 * maxn];
void update (int l, int r, int pos, int x, int val){
    if (l == r){
        tree [pos] += val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) update (l, mid, pos << 1, x, val);
    else update (mid + 1, r, pos << 1 | 1, x, val);
    tree [pos] = tree [pos << 1] + tree [pos << 1 | 1];
}
bool query (int l, int r, int pos, int ql, int qr){
    if (ql <= l && r <= qr) return !tree [pos];
    if (l > qr || r < ql) return 1;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) && query (mid + 1, r, pos << 1 | 1, ql, qr);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> q;
    while (q --){
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1){
            int x;
            cin >> x;
            drinks [l][x] ++;
            if (drinks [l][x] == 0){
                cnt_drinks [l] --;
                if (cnt_drinks [l] == 0) update (1, n, 1, l, -1);
            }
            else if (drinks [l][x] == 1){
                cnt_drinks [l] ++;
                if (cnt_drinks [l] == 1) update (1, n, 1, l, 1);
            }
            r ++;
            drinks [r][x] --;
            if (drinks [r][x] == 0){
                cnt_drinks [r] --;
                if (cnt_drinks [r] == 0) update (1, n, 1, r, -1);
            }
            else if (drinks [r][x] == -1){
                cnt_drinks [r] ++;
                if (cnt_drinks [r] == 1) update (1, n, 1, r, 1);
            }
        }
        else{
            cout << query (1, n, 1, l + 1, r) << '\n';
        }
    }

}
