#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;
/// postavi granici i q zarqza
/// takava hubava jena razplakvash ti
/// den mporo den mporo tinakano
/// moi gelas se koito kaitahano

mt19937_64 random_generator(237999531);
const int maxn = 2e5 + 3;
const long long mod = 1e12 + 7;
const long long inf = 1e18;

int n, q;
void read()
{
    cin >> n >> q;
}

struct node
{
    long long mins, maxs, lazy;
    node() {mins = maxs = lazy = 0;}
};

node tr[maxn * 4];
void push(int v, int l, int r)
{
    tr[v].mins += tr[v].lazy;
    tr[v].maxs += tr[v].lazy;

    if (l != r)
        tr[v * 2].lazy += tr[v].lazy, tr[v * 2 + 1].lazy += tr[v].lazy;

    tr[v].lazy = 0;
}

void merge(int v)
{
    tr[v].mins = min(tr[v * 2].mins, tr[v * 2 + 1].mins);
    tr[v].maxs = max(tr[v * 2].maxs, tr[v * 2 + 1].maxs);
}

void update(int v, int l, int r, int ll, int rr, long long add)
{
    push(v, l, r);
    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr)
    {
        tr[v].lazy += add;
        push(v, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(v * 2, l, mid, ll, rr, add);
    update(v * 2 + 1, mid + 1, r, ll, rr, add);

    merge(v);
}

long long get_min(int v, int l, int r, int ll, int rr)
{
    push(v, l, r);
    if (l > rr || r < ll)
    return inf;

    if (l >= ll && r <= rr)
    return tr[v].mins;

    int mid = (l + r) / 2;
    return min(get_min(v * 2, l, mid, ll, rr), get_min(v * 2 + 1, mid + 1, r, ll, rr));
}

long long get_max(int v, int l, int r, int ll, int rr)
{
    push(v, l, r);
    if (l > rr || r < ll)
    return -inf;

    if (l >= ll && r <= rr)
    return tr[v].maxs;

    int mid = (l + r) / 2;
    return max(get_max(v * 2, l, mid, ll, rr), get_max(v * 2 + 1, mid + 1, r, ll, rr));
}

long long xx[maxn];
void solve()
{
    for (int i = 0; i < maxn; i++)
        xx[i] = random_generator() % mod;

    while (q--)
    {
        int type;
        cin >> type;

        if (type == 1)
        {
            int l, r, x;
            cin >> l >> r >> x;

            update(1, 1, n, l, r, xx[x]);
        }

        else
        {
            int l, r;
            cin >> l >> r;

            if (get_max(1, 1, n, l, r) == get_min(1, 1, n, l, r))
            cout << 1 << endl;

            else
                cout << 0 << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
