#include <bits/stdc++.h>
#include "periods.h"

using namespace std;

const int maxn = 1e4 + 3;

vector <int> get_divisors(int n)
{
    vector <int> ans;
    for (int i = 2; 1ll * i * i <= n; i++)
    if (n % i == 0)
    {
        ans.push_back(i);
        if (1ll * i * i != n)
        ans.push_back(n / i);
    }

    ans.push_back(1);
    sort (ans.begin(), ans.end());
    return ans;
}

bitset <maxn> bs[maxn];
vector <int> findPeriods(int n)
{
    vector <int> ans(n, 0);
    vector <bool> is(n+1, true);

    int curr_idx = 1;
    ans[0] = 1;
    for (int i = 2; i <= n; i++)
    {
        vector <int> d = get_divisors(i);
        ans[i-1] = i;

        for (auto j: d)
        {
            if (!is[j])
            continue;

            bool curr_can = true;
            for (int k = i - j + 1; k < i; k++)
            if (!bs[k][k-j])
            {
                curr_can = false;
                break;
            }

            if (!curr_can)
                continue;

            if (hasPeriod(i, j))
            {
                ans[i-1] = j;
                break;
            }
        }

        for (int p = ans[i-1]; p < i; p++)
        if (p % ans[i-1] == 0)
            for (int j = i - p; j >= 1; j -= p)
            bs[i][j] = true;

        for (auto j: d)
        if (j % ans[i-1] != 0)
        is[j] = false;
    }

    return ans;
}
