#include<bits/stdc++.h>
using namespace std;

const long long mod1 = 1e9 + 7;
const long long mod2 = 1e9 + 9;
const int mn = 2e5 + 4;
long long a[mn], b[mn];

long long fpow(int p, const long long &mod)
{
    long long ans = 1, x = 2;
    while(p > 0){
        if(p & 1){
            ans = (ans*x)%mod;
        }
        x = (x*x)%mod;
        p >>= 1;
    }
    return (ans+1ll);
}

int main()
{
        ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin>>n>>q;
    fill(a, a+n+1, 1ll);
    fill(b, b+n+1, 1ll);
    int query, x, y, drink;
    while(q--){
        cin>>query;
        if(query == 1){
            cin>>x>>y>>drink;
            long long add1 = fpow(drink, mod1);
            long long add2 = fpow(drink, mod2);
            for(int i=x;i<=y;++i){
                a[i] *= add1;
                b[i] *= add2;
            }
//            for(int i=1;i<=n;++i)cout<<a[i]<<' ';
//            cout<<'\n';
        }
        else{
            cin>>x>>y;
            bool bb=true;
            for(int i=x;i<y;++i){
                if(a[i] != a[i+1] || b[i] != b[i+1]){
                    bb=false;
                    break;
                }
            }
            cout<<(bb ? "1\n" : "0\n");
        }
    }
}
