#include<iostream>
#define MOD 1000000007
using namespace std;
long long seg[4000000];
long long lazy[4000000];
long long n=7;
long long add(long long l,long long r,long long i,long long ql,long long qr,long long q){
    //cout<<"node: "<<i<<" "<<l<<" "<<r<<endl;
    if(qr<l || ql>r){
        return (seg[i]+lazy[i]*(r-l+1))%MOD;
    }
    if(ql<=l && qr>=r){
        lazy[i]+=q;
        lazy[i]%=MOD;
        return (seg[i]+lazy[i]*(r-l+1))%MOD;
    }
    if(l==r)return (seg[i]+lazy[i]*(r-l+1))%MOD;;
    lazy[i*2+1]+=lazy[i];
    lazy[i*2+1]%=MOD;
    lazy[i*2+2]+=lazy[i];
    lazy[i*2+2]%=MOD;
    lazy[i]=0;
    long long addl=add(l,(l+r)/2,i*2+1,ql,qr,q),addr=add((l+r)/2+1,r,i*2+2,ql,qr,q);
    //cout<<"check: "<<i<<" "<<addl<<" "<<addr<<endl;
    long long total=(addl+addr)%MOD;
    seg[i]=total;
    return total;
}
long long query(long long l,long long r,long long i,long long ql,long long qr){
    if(qr<l || ql>r){
        return 0;
    }
    if(ql<=l && qr>=r){
        return (seg[i]+lazy[i]*(r-l+1))%MOD;
    }
    if(l==r)return 0;
    lazy[i*2+1]+=lazy[i];
    lazy[i*2+1]%=MOD;
    lazy[i*2+2]+=lazy[i];
    lazy[i*2+2]%=MOD;
    lazy[i]=0;
    long long total=(query(l,(l+r)/2,i*2+1,ql,qr)+query((l+r)/2+1,r,i*2+2,ql,qr))%MOD;
    return total;
}
void output(){
    long long l=2;
    for(long long i=1;i<=n*2+1;i++){
        if(i==l){
            cout<<endl;
            l*=2;
        }
        cout<<" ("<<seg[i-1]<<" "<<lazy[i-1]<<") ";
    }
}
long long pows[200000];
int main(){
    pows[0]=1;
    long long n,q;
    cin>>n>>q;
    for(int i=1;i<=100000;i++){
        pows[i]=(pows[i-1]*n)%MOD;
    }
    //cout<<pows[1000]<<endl;

    while(q--){
        long long a,l,r,b;
        cin>>a;
        if(a==1){
            cin>>l>>r>>b;
            add(0,n,0,l,r,pows[b]);
            /*for(int i=1;i<=n;i++){
                cout<<query(0,n,0,i,i)<<" ";
            }*/
            //cout<<endl;
        }else if(a==2){
            cin>>l>>r;
            long long total=query(0,n,0,l,r);
            /*long long single1=query(0,n,0,l,l);
            long long single2=query(0,n,0,r,r);
            long long single3=query(0,n,0,(l+r)/2,(l+r)/2);
            if((single1*(r-l+1))%MOD==total && (single2*(r-l+1))%MOD==total && (single3*(r-l+1))%MOD==total){
                cout<<1<<endl;
            }else{
                cout<<0<<endl;
            }*/
            bool ok=1;
            for(int i=l;i<=r;i++){
                long long single=query(0,n,0,i,i);
                if((single*(r-l+1))%MOD!=total){
                    ok=0;
                    break;
                }
            }
            cout<<ok<<endl;
        }else{
            output();
            cout<<endl;
        }
    }
    return 0;
}
