#include<bits/stdc++.h>
using namespace std;

const int nmax=2e5+42;

int n,q,inp[nmax];

mt19937 rng(42);

unsigned long long hsh[nmax],cur_hsh[nmax];

struct info
{
    unsigned long long lazy,mini,maxi;
};
info tree[4*nmax];

info actual(info cur)
{
    cur.mini+=cur.lazy;
    cur.maxi+=cur.lazy;
    cur.lazy=0;
    return cur;
}
info my_merge(info l,info r)
{
    l=actual(l);
    r=actual(r);

    l.mini=min(l.mini,r.mini);
    l.maxi=max(l.maxi,r.maxi);

    return l;
}

void push(int node)
{
    tree[node*2].lazy+=tree[node].lazy;
    tree[node*2+1].lazy+=tree[node].lazy;
    tree[node].lazy=0;
}
void update(int node,int l,int r,int lq,int rq,unsigned long long val)
{
    if(l==lq&&r==rq)
    {
        tree[node].lazy+=val;
        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)update(node*2,l,av,lq,min(av,rq),val);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,val);

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);
}

info query(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)return actual(tree[node]);

    push(node);

    info ret;
    ret.lazy=0;
    ret.maxi=0;
    ret.mini=(1LL<<62);

    int av=(l+r)/2;

    if(lq<=av)ret=my_merge(ret,query(node*2,l,av,lq,min(av,rq)));
    if(av<rq)ret=my_merge(ret,query(node*2+1,av+1,r,max(av+1,lq),rq));

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);

    return ret;
}
int main()
{
    for(int i=0;i<nmax;i++)
        for(int j=0;j<40;j++)
            hsh[i]=hsh[i]*2+rng()%2;

    scanf("%i%i",&n,&q);

    for(int i=1;i<=q;i++)
    {
        int type;
        scanf("%i",&type);

        if(type==1)
        {
            int l,r,x;

            scanf("%i%i%i",&l,&r,&x);

            update(1,1,n,l,r,hsh[x]);
        }
        else
        {
            int l,r;

            scanf("%i%i",&l,&r);

            info cur=query(1,1,n,l,r);

            printf("%i\n",cur.mini==cur.maxi);
        }
    }

    return 0;
}