#include "periods.h"
#include <bits/stdc++.h>
using namespace std;
/*
static int n;
static std::vector<int> arr;
static std::vector<int> retPeriods;

static void input()
{
    std::cin >> n;
    arr.resize(n);
    for (int& elem : arr)
    {
        std::cin >> elem;
    }
}

static void output()
{
    for (int& period : retPeriods)
    {
        std::cout << period << " ";
    }
}

static int numQs;
bool hasPeriod(int len, int period)
{
    ++numQs;

    if (len <= 0 || len > n || period <= 0)
    {
        std::cerr << "Invalid query" << std::endl;
        exit(0);
    }

    if (len % period != 0) return false;

    for (int i = period; i < len; ++i)
    {
        if (arr[i] != arr[i - period]) return false;
    }

    return true;
}
*/
std::vector<int> findPeriods(int n)
{
    vector<int> outp(n,-1);

    outp[0]=1;

    for(int sz=1;sz<=n;sz++)
    {
        int ok=sz;

        while(ok<=n)
        {
            if(outp[ok-1]==-1)
            {
                if(hasPeriod(ok,sz))
                {
                    outp[ok-1]=sz;
                }
                else break;
            }
            else if(sz%outp[ok-1])break;

            ok=ok+sz;
        }
    }

    return outp;
}
/*
int main()
{
    std::ios::sync_with_stdio(false);

    input();

    numQs = 0;
    retPeriods = findPeriods(n);

    std::cerr << "Number of queries: " << numQs << std::endl;
    output();

    return 0;
}
*/
