#include "periods.h"
#include <bits/stdc++.h>
using namespace std;
/*
static int n;
static std::vector<int> arr;
static std::vector<int> retPeriods;

static void input()
{
    //n=12;
    arr={1,2,1,1,2,1,1,2,1,1,1,1};


    //std::cin >> n;
    n=1e5;
    arr.resize(n);

    int pointer=0;
    for (int& elem : arr)
    {
        //std::cin >> elem;
        elem=pointer;
    }


    arr={1,1,1,1,4,5,6,7};
    n=arr.size();
}

static void output()
{
    for (int& period : retPeriods)
    {
        std::cout << period << " ";
    }
}

static int numQs;
bool hasPeriod(int len, int period)
{
    cout<<"has "<<len<<" "<<period<<endl;

    ++numQs;

    if (len <= 0 || len > n || period <= 0)
    {
        std::cerr << "Invalid query" << std::endl;
        exit(0);
    }

    if (len % period != 0) return false;

    for (int i = period; i < len; ++i)
    {
        if (arr[i] != arr[i - period]) return false;
    }

    return true;
}
*/
map< pair<int,int>,int> seen;

bool my_has_period(int pos,int len)
{
    if(pos==len)return 1;

    if(seen.count({pos,len}))return seen[{pos,len}];

    seen[{pos,len}]=hasPeriod(pos,len);

    return seen[{pos,len}];
}

const int nmax=1e5+42;

vector<int> dvd[nmax];

vector<int> outp;

bool fake(int pos,int len)
{
    if(pos==len)return 0;

    //cout<<"fake "<<pos<<" "<<len<<endl;

    for(auto w:dvd[pos])
        if(outp[pos-1-w]>=1&&w%outp[pos-1-w]==0&&w<len)return 1;

    return 0;
}

std::vector<int> findPeriods(int n)
{
    for(int i=1;i<=n;i++)
        for(int j=2*i;j<=n;j+=i)
            dvd[j].push_back(i);

    outp={};
    for(int i=0;i<n;i++)outp.push_back(-1);

    outp[0]=1;

    int pos=2;

    while(pos<=n&&my_has_period(pos,1))
    {
        outp[pos-2]=1;
        outp[pos-1]=1;

        pos+=2;
    }

    for(int sz=1;sz<=n;sz++)
    {
        int ok=sz;

        while(ok<=n)
        {
            if(outp[ok-1]==-1)
            {
                if(fake(ok,sz))break;

                if(ok==sz||my_has_period(ok,sz))
                {
                    outp[ok-1]=sz;
                }
                else break;
            }
            else if(sz%outp[ok-1])break;

            ok=ok+sz;
        }
    }

    return outp;
}
/*
int main()
{
    std::ios::sync_with_stdio(false);

    input();

    numQs = 0;
    retPeriods = findPeriods(n);

    std::cerr << "Number of queries: " << numQs << std::endl;
    output();

    return 0;
}
*/
