#include <bits/stdc++.h>
#include "periods.h"

#pragma GCC optimize "-O3"

/*
#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
*/

using namespace std;

mt19937 gen(45);

int rand(int l, int r) {
    return l + gen() % (r - l + 1);
}

vector<int> findPeriods(int n) {
    vector<int> answer(n);

    for (int i = 0; i < n; i++) {
        vector<int> divs;

        for (int j = 1; j * j <= (i + 1); j++) {
            if ((i + 1) % j == 0) {
                divs.emplace_back(j);

                if ((i + 1) / j != j) {
                    divs.emplace_back((i + 1) / j);
                }
            }
        }

        sort(divs.begin(), divs.end());

        vector<bool> chosen(divs.size(), false);
        chosen.back() = true;
        int low = divs.size() - 2;

        answer[i] = i + 1;

        while (low >= 0) {
            bool allChosen = true;

            for (int i = 0; i <= low; i++) {
                if (!chosen[i]) {
                    allChosen = false;
                    break;
                }
            }

            if (allChosen) {
                break;
            }

            int idToAsk = -1;

            do {
                idToAsk = rand(0, low);
            } while (chosen[idToAsk]);

            if (hasPeriod(i + 1, divs[idToAsk])) {
                answer[i] = divs[idToAsk];
                low = idToAsk - 1;
            }

            chosen[idToAsk] = true;
        }
    }

    return answer;
}
