#include <iostream>
#include <vector>
#include <map>

#define ENDL '\n'

namespace {
using cup_t = std::map<int, int>;
}  // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, q;
    std::cin >> n >> q;

    std::vector<cup_t> cups(n);

    while (q--) {
        int t, l, r;
        std::cin >> t >> l >> r;

        --l, --r;

        if (t == 1) {
            int x;
            std::cin >> x;
            for (auto i = l; i <= r; ++i) {
                ++cups[i][x];
            }
        }
        else if (t == 2) {
            bool f = true;
            for (auto i = l + 1; i <= r; ++i) {
                if (cups[i - 1] != cups[i]) {
                    f = false;
                    break;
                }
            }

            std::cout << f << ENDL;
        }
    }

    return 0;
}
