#include "periods.h"

std::vector<int> findPeriods(int n) {
    std::vector<int> res(n);
    res[0] = 1;

    for (auto i = 2; i <= n; ++i) {
        for (auto j = 1; j <= i; ++j) {
            if (i % j != 0) {
                continue;
            }

            if (hasPeriod(i, j)) {
                res[i - 1] = j;
                break;
            }
        }
    }

    return res;
}
