#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
#include "periods.h"

using namespace std;

//
//bool hasPeriod(int len, int period);
//

const int N = 1e5;
int n;
vector<int> pr;
int sieve[N];
void fillSieve(int curr) {
    int temp = curr*curr;
    while (temp < n) {
        sieve[temp] = 1;
        temp += curr;
    }
}

void findPrimes() {
    pr.pb(1);
    for (int i=2; i<n; i++) {
        if (!sieve[i]) {
            pr.pb(i);
        }
    }
}

vector<int> findPeriods(int nloc) {
    n = nloc;
    vector<int> ans(n);
    for (int i=1; i<=n; i++) {
        ans[i-1] = i;
    }

    findPrimes();

    for (auto id : pr) {
        //cerr<<id<<endl;
        int l = 2, r = n/id + 1;
        while (r > l) {
            int mid = (l+r) / 2;
            if (hasPeriod(mid*id, id)) {
                l = mid+1;
            } else {
                r = mid;
            }
        }
        for (int i=id*2; i<l*id; i+=id) {
            ans[i-1] = min(ans[i-1], id);

        }
    }

    return ans;
}
/*
3
0 0 1

5
0 1 0 1 0

6
0 1 0 1 0 1

5
0 0 0 1 0

5
0 0 0 0 1
*/

/*
static std::vector<int> arr;
static std::vector<int> retPeriods;

static void input()
{
    std::cin >> n;
    arr.resize(n);
    for (int& elem : arr)
    {
        std::cin >> elem;
    }
}

static void output()
{
    for (int& period : retPeriods)
    {
        std::cout << period << " ";
    }
}

static int numQs;
bool hasPeriod(int len, int period)
{
    cerr<<len<<' '<<period<<endl;
    ++numQs;

    if (len <= 0 || len > n || period <= 0)
    {
        std::cerr << "Invalid query" << std::endl;
        exit(0);
    }

    if (len % period != 0) return false;

    for (int i = period; i < len; ++i)
    {
        if (arr[i] != arr[i - period]) return false;
    }

    return true;
}

int main()
{
    std::ios::sync_with_stdio(false);

    input();

    numQs = 0;
    retPeriods = findPeriods(n);

    std::cerr << "Number of queries: " << numQs << std::endl;
    output();

    return 0;
}*/
