#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
#include "periods.h"

using namespace std;

const int N = 1e5;
int np;
vector<int> pr;
int sieve[N];
bool hasMin[N];
void fillSieve(int curr) {
    int temp = curr*curr;
    while (temp < np) {
        sieve[temp] = 1;
        temp += curr;
    }
}

void findPrimes() {
    pr.pb(1);
    for (int i=2; i<np; i++) {
        if (!sieve[i]) {
            pr.pb(i);
        }
    }
}

vector<int> check;

void calcCheck(int id) {
    check.clear();
    for (int i=id*2; i<=np; i+=id) {
        if (!hasMin[i]) {
            check.pb(i);
        }
    }
}

map<pair<int, int>, bool> mp;
bool hasPeriodMoe(int len, int period) {
    if (mp.find({len, period}) == mp.end()) {
        mp[{len, period}] = hasPeriod(len, period);
    }
    return mp[{len, period}];
}

vector<int> findPeriods(int nloc) {
    np = nloc;
    vector<int> ans(np);
    for (int i=1; i<=np; i++) {
        ans[i-1] = i;
    }
    hasMin[0] = 1;

    findPrimes();

    for (auto id : pr) {
        //cerr<<id<<endl;
        calcCheck(id);
        int l = 0, r = sz(check);
        while (r > l) {
            int mid = (l+r) / 2;
            if (hasPeriodMoe(check[mid], id)) {
                l = mid+1;
            } else {
                r = mid;
            }
        }
        for (int i=0; i<l; i++) {
            ans[check[i]-1] = id;
            hasMin[check[i]] = 1;
        }
    }

    return ans;
}
/*
3
0 0 1

5
0 1 0 1 0

6
0 1 0 1 0 1

5
0 0 0 1 0

5
0 0 0 0 1
*/
