#include <bits/stdc++.h>

using namespace std;

#define MAX 210000

long long n, q, a, b, x;

double lazy[4 * MAX], inf =  LLONG_MAX, ty;

pair<double, double> tr[4 * MAX], tmp;

bool erat[7 * MAX];

vector<long long> pr;

void update(int v, int l, int r, int ql, int qr, double val)
{
	
	if(lazy[v] != 0)
	{
		tr[v].first += lazy[v];
		tr[v].second += lazy[v];
		if(l != r)
		{
			lazy[v * 2] += lazy[v];
			lazy[v * 2 + 1] += lazy[v];
		}
		lazy[v] = 0;
	}
	if(r < l)return ;
	if(ql > r || qr < l)return;
		
	if(l == r)
	{
		tr[v].first += val;
		tr[v].second += val;
		return ;
	}
	if(ql <= l && r <= qr)
	{
		tr[v].first += val;
		tr[v].second += val;
		lazy[v * 2] += val;
		lazy[v * 2 + 1] += val;
		return ;
	}
	int mid = (l + r) / 2;
	update(v * 2, l, mid, ql, qr, val);
	update(v * 2 + 1, mid + 1, r, ql, qr, val);
	tr[v].first = min(tr[v * 2].first, tr[v * 2 + 1].first);
	tr[v].second = max(tr[v * 2].second, tr[v * 2 + 1].second);
}

pair<double, double> query(int v, int l, int r, int ql, int qr)
{

	if(lazy[v] != 0)
	{
		tr[v].first += lazy[v];
		tr[v].second += lazy[v];
		if(l != r)
		{
			lazy[v * 2] += lazy[v];
			lazy[v * 2 + 1] += lazy[v];
		}
		lazy[v] = 0;
	}
	if(ql > r || qr < l)return {inf , -1214};
	if(ql <= l && r <= qr)
	{
		return tr[v];
	}
	int mid = (l + r) / 2;
	pair<double, double > t1 = query(v * 2, l, mid, ql, qr);
	pair<double, double >t2 = query(v * 2 + 1, mid + 1, r, ql, qr);
	return {min(t1.first, t2.first), max(t1.second, t2.second)};
}
 
int main()
{
	inf *= 109073024;
	erat[0] = erat[1] = 1;
	for(long long i = 2; i < 7 * MAX; i++)
	{
		if(erat[i] == 0)
		{
			pr.push_back(i);
			for(long long j = i * i; j < 7 * MAX; j += i)erat[j] = 1;
		}
	}
	scanf("%lld%lld", &n, &q);
	for(int i = 0; i < q; i++)
	{
		scanf("%lld", &a);
		if(a == 1)
		{
			scanf("%lld%lld%lld", &a, &b, &x);
			ty = 200007;
			ty = ty * pr[x];
			ty = ty * x;
			update(1, 1, n, a, b, ty);
		}
		else
		{
			scanf("%lld%lld", &a, &b);
			tmp = query(1, 1, n, a, b);
			if(tmp.first != tmp.second)printf("0\n");
			else printf("1\n");
			//cout << tmp.first << " " << tmp.second << endl;
		}
	}

	return 0;
}

/*

4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 2


4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2


*/