#include "periods.h"
#include <bits/stdc++.h>

using namespace std;

#define MAX 110000

bool erat[MAX];

unordered_map<int, bool> m[MAX];

std::vector<int> findPeriods(int n)
{
	erat[0] = erat[1] = 1;
	for(long long i = 2; i < MAX; i++)
	{
		if(erat[i] == 0)
		{
			for(long long j = i * i; j < MAX; j += i)erat[j] = 1;
		}
	}
	bool fl;
	vector<int> p;
	p.resize(n);
	for(int i = n; i > 0; i--)
	{
		fl = false;
		if(p[i - 1] != 0)continue;
		for(int j = 1; j <= sqrt(i) + 1; j++)
		{
			if(i / j < j)continue;
			if(i % j != 0)continue;
			//if(p[i - 1] != 0)if(p[i - 1] % j != 0)continue;
			fl = true; 
			if(i * 2 <= n)if(m[2 * i].count(j) == 1 && m[2 * i][j] == 0)fl = false;
			
			if(fl == false)
			{ 
				m[i][j] = 0;
				continue;
			}
			if(p[i - 1] != 0 && p[i - 1] <= j) continue;
			if(p[i - 1] != 0)
			{
				if(hasPeriod(i, j) == 1)
				{
					m[i][j] = 1;
					for(int k = i; k >= 1; k -= j)p[k - 1] = j;
				}
				else m[i][j] = 0;
				
			}
			if(p[i - 1] != 0 && p[i - 1] < i / j)
			{
				if(hasPeriod(i, j) == 1)
					{
						m[i][j] = 1;
						for(int k = i; k >= 1; k -= j)p[k - 1] = j;
					}
					else m[i][j] = 0;
				continue;
			}
			
				if(hasPeriod(i, i / j) == 1)
				{
					m[i][i / j] = 1;
					for(int k = i; k >= 1; k -= i / j)p[k - 1] = i / j;
					if(hasPeriod(i, j) == 1)
					{
						m[i][j] = 1;
						for(int k = i; k >= 1; k -= j)p[k - 1] = j;
					}
					else m[i][j] = 0;
				} 	
				else m[i][i / j] = 0;
			
			
		}
		if(fl == false || erat[p[i - 1]] == 0)
		{
			if(hasPeriod(i, 1) == 1)
			{ 
				m[i][1] = 1;
				for(int j = i; j >= 1; j--)p[j - 1] = 1;
			}
			else 
			{	
				m[i][1] = 0;
				p[i - 1] = i;	
			}
		}
		if(p[i - 1] == 0)p[i - 1] = i;
	}
	return p;
}





