#include<iostream>
#include<cstdio>
#include<vector>
#include<algorithm>
using namespace std;

vector<int>glass[105];
int n,q;

void insert(int l, int r, int x)
{
	for(int i = l; i <=r; i++) glass[i].push_back(x);
}

bool compare(int l, int r)
{
	for(int i = l; i <= r; i++)
	{
		sort(glass[i].begin(),glass[i].end());
	}
	
	//compare length
	int start = glass[l].size();
	for(int i = l+1; i<=r; i++) 
	{
		if(start != glass[i].size()) return 0;
	}
	
	//compare values;
	for(int j = 0; j < glass[l].size(); j++)
	{
		start = glass[l][j];
		for(int i = l+1; i <=r; i++)
		{
			if(start != glass[i][j]) return 0;
		}
	}
	return 1;
}

int main()
{
	scanf("%d%d",&n,&q);
	
	int type,x,l,r;
	for(int i = 0; i < q; i++)
	{
		scanf("%d",&type);
		
		if(type == 1)
		{
			scanf("%d%d%d",&x,&l,&r);
			l--;r--;
			insert(l,r,x);
		}
		else
		{
			scanf("%d%d",&l,&r);
			l--;r--;
			bool ans = compare(l,r);
			cout<<ans<<endl;
		}
	}
}
