#include<bits/stdc++.h>
using namespace std;

struct segment
{
	int from, to;
	int maxe, sum;
	int lp;
	
	segment *l, *r;
	
	segment()
	{
		this->l = this->r = NULL;
		this->sum = this->maxe = 0;
		this->lp = 0;
	}
	
}*root;

vector<int> glass[505];
int n,q;

void build(int from, int to, segment *t)
{
	t->from = from;
	t->to = to;
	
	if(from == to)
	{
		return;
	}
	
	t->l = new segment();
	build(from, (from+to)/2, t->l);
	
	t->r = new segment();
	build(( from+to)/2 + 1, to, t->r);	
}

pair<int,int> search(int from, int to, segment *t)
{
	if(t->lp != 0)
	{
		//printf("from = %d to = %d maxe = %d, sum = %d\n",t->from, t->to, t->maxe, t->sum);
		if( t->l != NULL ) 
		{
			t->l->lp += t->lp;
			t->r->lp += t->lp;
		}
		//printf("lp= %d \n",t->lp);
		t->sum = t->sum + (t->to - t->from + 1)*t->lp;
		t->maxe += t->lp;
		//printf("from = %d to = %d maxe = %d, sum = %d\n",t->from, t->to, t->maxe, t->sum);
		t->lp = 0;
	}
	if(t->to < from || t->from > to) return make_pair(0,0);
	else if(from <= t->from && t->to <= to) 
	{
		//printf("from = %d to = %d maxe = %d, sum = %d\n",t->from, t->to, t->maxe, t->sum);
		return make_pair(t->maxe, t->sum);
	}
	else
	{
		if(t->l != NULL)
		{
			pair<int, int> f = search(from, to, t->l);
			pair<int, int> f1 = search(from,to, t->r);
			return make_pair(max(f.first, f1.first), f.second + f1.second);
		}
		else return make_pair(0,0);
	}
}

void insert(int from, int to, segment *t)
{
	if(t->lp != 0)
	{
		//printf("ellie\n");
		if( t->l != NULL ) 
		{
			t->l->lp += t->lp;
			t->r->lp += t->lp;
		}
		t->sum = t->sum + (t->to - t->from + 1)*t->lp;
		t->maxe += t->lp;
		t->lp = 0;
	}
	if(t->to < from || t->from > to) return;
	else if(from <= t->from && t->to <= to)
	{
		//printf("from = %d to = %d maxe = %d, sum = %d\n",t->from, t->to, t->maxe, t->sum);
		t->sum = t->sum + (t->to - t->from + 1);
		t->maxe++;
		if( t->l != NULL)
		{
			t->l->lp++;
			t->r->lp++;
		}
		
		return;
	}
	else
	{
		if(t->l != NULL)
		{
			insert(from,to,t->l);
			insert(from,to,t->r);
			
			t->sum = t->l->sum + t->r->sum;
			t->maxe = max(t->l->maxe, t->r->maxe);
			return;
		}
	}
}


void insertt(int l, int r, int x)
{
	for(int i = l; i <=r; i++) 
	{
		if(i >=0  && i <= 505) glass[i].push_back(x);
		//a.push_back(x);
	}

}

int compare(int l, int r)
{
	//compare length
	int start = glass[l].size();
	for(int i = l+1; i<=r; i++) 
	{
		if(start != glass[i].size()) return 0;
	}
	
	for(int i = l; i <= r; i++)
	{
		sort(glass[i].begin(),glass[i].end());
	}
	
	//compare values;
	for(int j = 0; j < glass[l].size(); j++)
	{
		start = glass[l][j];
		for(int i = l+1; i <=r; i++)
		{
			if(start != glass[i][j]) return 0;
		}
	}
	return 1;
}

/*int compare(int l, int r)
{
	return 1;
}*/

int main()
{
	scanf("%d%d",&n,&q);
	
	if(n < 505)
	{
		int type,x,l,r;
		for(int i = 0; i < q; i++)
		{
			scanf("%d",&type);
			
			if(type == 1)
			{
				scanf("%d%d%d",&l,&r,&x);
				l--;r--;
				insertt(l,r,x);
			}
			else
			{
				scanf("%d%d",&l,&r);
				l--;r--;
				int ans = compare(l,r);
				cout<<ans<<endl;
			}
		}
	}
	else
	{
		scanf("%d%d",&n,&q);
	
		root = new segment();
		
		build(0,n-1,root);
		
		int type,x,l,r;
		for(int i = 0; i < q; i++)
		{
			scanf("%d",&type);
			
			if(type == 1)
			{
				scanf("%d%d%d",&l,&r,&x);
				l--;r--;
				insert(l,r,root);
			}
			else
			{
				scanf("%d%d",&l,&r);
				l--;r--;
				pair<int, int> ans = search(l,r,root);
				//printf("maxe = %d sum = %d\n",ans.first, ans.second);
				int sol;
				if( ans.first*(r-l+1) == ans.second) sol = 1;
				else sol = 0;
				cout<<sol<<endl;
			}
		}
	}
}
