#include<bits/stdc++.h>
#include "periods.h"
using namespace std;

int const maxn = 1e5+5;

vector<int>v;

bool used[maxn];
vector<int>primes;

void reshe(int n)
{
    int i,j;

    for(i=2; i<=n/2; i++)
    {
        if(!used[i])
        {
            primes.push_back(i);

            for(j=i;j<=n/2;j+=i)
                used[j] = true;
        }
    }
}

int P1;
int rek(int i)
{

    if(i<=P1)
        return 1;
    if(used[i])return v[i-1];

    used[i] = true;
    int j;

    int k,sz=primes.size();

    for(k=0;k<sz;k++)
    {
        j = primes[k];
        if(j > sqrt(i))break;
        if(i % j == 0 && hasPeriod(i,i/j))
        {
            v[i-1] = min(v[i-1],rek(i/j));
            break;
        }
    }

    if(v[i-1] == 1)P1 = i;
    return v[i-1];
}

std::vector<int> findPeriods(int n)
{
    v.resize(n);
    int i;
    reshe(n);

    memset(used,0,sizeof(used));

    for(i=1;i<=n;i++)
        v[i-1] = i;

    int l=1,r=n,mid;

    while(l<r)
    {
        mid = (l+r)/2;
        if(mid == 1){l+=1;break;}
        if(hasPeriod(mid,1))
            l = mid+1;
        else r = mid-1;
    }

    P1 = l-1;
    used[1] = true;

    for(i=n;i>0;i--)
        if(!used[i])rek(i);

    for(i=1;i<=n;i++)
        if(i<=P1)v[i-1] = 1;

    return v;
}
