#include<iostream>
#include<vector>
#include<cstdio>
#include<set>
using namespace std;

int n, qs;
vector<multiset<int> > cups;

int main()
{
    scanf("%d%d", &n, &qs);
    cups.resize(n+1);

    for (int br=0; br<qs; br++)
    {
        int q;
        scanf("%d", &q);

        if (q == 1)
        {
            int l, r, x;
            scanf("%d%d%d", &l, &r, &x);
            for (int i=l; i<=r; i++)
            {
                cups[i].insert(x);
            }
        }
        else if (q == 2)
        {
            int l, r;
            scanf("%d%d", &l, &r);
            if (l == r) cout<<1<<endl;
            else
            {
                multiset<int> comp = cups[l];
                bool res = true;
                for (int i=l+1; i<=r; i++)
                {
                    if (comp != cups[i])
                    {
                        res = false;
                        break;
                    }
                }
                cout<<std::noboolalpha<<res<<endl;
            }
        }
    }

    return 0;
}
