#include <iostream>
#include <vector>
#include <random>

using namespace std;

mt19937 rnd(22);
const int MAXN = 2e5 + 5;

int n;
long long a[MAXN];

long long code[MAXN];

void init()
{
    for(int i = 1;i<=1e5;i++) code[i] = rnd();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    init();

    int Q;
    cin >> n >> Q;

    while(Q--)
    {
        int type, l, r, x;

        cin >> type >> l >> r;
        if(type==1) cin >> x;

        l--;r--;
        if(type==1)
        {
            for(int i = l;i<=r;i++) a[i] += code[x];
        }
        else
        {
            bool fail = false;
            for(int i = l;i<=r;i++)
            {
                if(a[i]!=a[l])
                {
                    fail = true;
                    break;
                }
            }

            cout << (fail^1) << '\n';
        }
    }
}
