#include <algorithm>
#include <iostream>
#include <vector>

#include "periods.h"
//#include "Lgrader.cpp"

using namespace std;

vector <int> getDivs(int x)
{
    vector <int> divs;
    for(int d = 1;d*d<=x;d++)
    {
        if(x%d==0)
        {
            divs.push_back(x);
            if(x/d!=d) divs.push_back(x/d);
        }
    }

    sort(divs.begin(), divs.end());
    return divs;
}

vector<int> findPeriods(int n)
{
    int last = 1;
    vector <int> periods(n);

    for(int i = 1;i<=n;i++)
    {
        int ans = -1;
        for(int p = last;p<=i;p++)
        {
            if(hasPeriod(i, p)==true)
            {
                ans = p;
                break;
            }
        }

        periods[i-1] = ans;
        last = ans;
    }

    return periods;
}
