#include <algorithm>
#include <iostream>
#include <vector>

#include "periods.h"
//#include "Lgrader.cpp"

using namespace std;

vector <int> getDivs(int x)
{
    vector <int> divs;
    for(int d = 1;d*d<=x;d++)
    {
        if(x%d==0)
        {
            divs.push_back(d);
            if(x/d!=d) divs.push_back(x/d);
        }
    }

    sort(divs.begin(), divs.end());
    return divs;
}

vector<int> findPeriods(int n)
{
    int last = 1;
    vector <int> periods(n);

    for(int i = 1;i<=n;i++)
    {
        int ans = -1;
        vector <int> divs = getDivs(i);

        //cout << i << ":";
        //for(int p: divs) cout << " " << p;
        //cout << '\n';

        for(int p: divs)
        {
            if(i-p>=p && periods[i-1-p]>p) continue;
            if(hasPeriod(i, p)==true)
            {
                ans = p;
                break;
            }
        }

        periods[i-1] = ans;
    }

    return periods;
}
