#include "periods.h"
///using namespace std;
const int MAXN=1e5+10;
std::vector <int> primes;
bool er[MAXN];
void eratosten(int n) {
    for (int i=4;i<=n;i+=2) er[i]=true;
    primes.push_back(2);
    for (long long i=3;i<=n;i++) {
        if (!er[i]) {
            primes.push_back(i);
            for (long long j=i*i;j<=n;j+=2*i) er[j]=true;
        }
    }
}
std::vector<int> findPeriods(int n) {
    eratosten(n);
    std::vector <int> ans;
    ans.push_back(1);
    int br=1;
    bool fl;
    for (int i=2;i<=n;i++) {
        if (ans[br-1]==1 && hasPeriod(i,1)) {
            ans.push_back(1);
            br++;
            continue;
        }
        fl=false;
        for (int j=0;primes[j]<i;j++) {
            if (i%j!=0) continue;
            if (ans[br-primes[j]+1]==j && hasPeriod(i,primes[j])) {
                ans.push_back(primes[j]);
                fl=true;
                continue;
            }
        }
        if (!fl) ans.push_back(i);
        br++;
    }
    return ans;
}
