#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define hash sdfdsf
#define merge dsfdsfsd
vector<ll>primes;
const ll target=2e5;
const ll MAXN=2e5+6;
const ll MAXM=1e6+6;
const ll mod1=1000200079;
const ll mod2=1000200101;
const ll mod3=1000200107;
const ll mod4=1000200127;
int p[MAXM];
ll b1[MAXN];
ll b2[MAXN];
ll b3[MAXN];
ll b4[MAXN];
struct hash
{
    ll h1,h2,h3,h4;
    hash()
    {
        h1=1;h2=1;h3=1;h4=1;
    }
    void pour(ll d)
    {
        h1*=b1[d];
        h2*=b2[d];
        h3*=b3[d];
        h4*=b4[d];
        h1%=mod1;
        h2%=mod2;
        h3%=mod3;
        h4%=mod4;
    }
};
bool eq(hash a,hash b)
{
    return a.h1==b.h1&&a.h2==b.h2&&a.h3==b.h3&&a.h4==b.h4;
}
void sieve()
{
    primes.push_back(2);
    for(int i=3;i<MAXM;i++)
    {
        //cout<<i<<endl;
        if(p[i]==0)
        {
            primes.push_back(i);
            if(primes.size()==target)
            {
                //cout<<"ok\n";
                break;
            }
            if(i<sqrt(MAXM))
            for(int j=i*i;j<MAXM;j+=2*i)
            {
                p[j]=1;
            }
        }
    }
    //cout<<primes.size()<<endl;
}
int n,q;
hash add(hash a,hash b)
{
    a.h1=(a.h1*b.h1)%mod1;
    a.h2=(a.h2*b.h2)%mod2;
    a.h3=(a.h3*b.h3)%mod3;
    a.h4=(a.h4*b.h4)%mod4;
    return a;
}
struct segment_tree
{
    struct node
    {
        hash hesh;
        bool all_equal;
        hash lazy;
    };
    node tree[4*MAXN];
    node merge(node n1,node n2)
    {
       // cout<<"%%%\n";
        node ret;
        if(n1.all_equal&&n2.all_equal&&eq(n1.hesh,n2.hesh))
        {
            ret.all_equal=1;ret.hesh=n1.hesh;
        }
        else
        {
            ret.all_equal=0;
        }
        return ret;
    }
    void push_lazy(int l,int r,int idx)
    {
        tree[idx].hesh=add(tree[idx].hesh,tree[idx].lazy);
        if(l!=r)
        {
            tree[idx*2].lazy=add(tree[idx*2].lazy,tree[idx].lazy);
            tree[idx*2+1].lazy=add(tree[idx*2+1].lazy,tree[idx].lazy);
        }
        tree[idx].lazy=hash();
    }
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            tree[idx].all_equal=1;
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        //cout<<"(\n";
        tree[idx]=merge(tree[idx*2],tree[idx*2+1]);
       // cout<<")\n";

    }
    void update(int l,int r,int ql,int qr,int idx,int val)
    {
        if(l>qr||r<ql)return;
        push_lazy(l,r,idx);
        if(l>=ql&&r<=qr)
        {
            tree[idx].lazy.pour(val);
            push_lazy(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,ql,qr,idx*2,val);
        update(mid+1,r,ql,qr,idx*2+1,val);
        tree[idx]=merge(tree[idx*2],tree[idx*2+1]);
    }
    node query(int l,int r,int ql,int qr,int idx)
    {
        push_lazy(l,r,idx);
        if(l>=ql&&r<=qr)
        {
            return tree[idx];
        }
        int mid=(l+r)/2;
        if(qr<=mid)
        {
            return query(l,mid,ql,qr,idx*2);
        }
        if(ql>mid)
        {
            return query(mid+1,r,ql,qr,idx*2+1);
        }
        node n1=query(l,mid,ql,qr,idx*2);
        node n2=query(mid+1,r,ql,qr,idx*2+1);
        return merge(n1,n2);
    }
    bool query(int l,int r)
    {
        node gg=query(1,n,l,r,1);
        return gg.all_equal;
    }
    void print(int l,int r,int idx)
    {

        cout<<l<<" "<<r<<" "<<idx<<":\n";
        cout<<tree[idx].hesh.h1<<" "<<tree[idx].hesh.h2<<endl;
        cout<<tree[idx].lazy.h1<<" "<<tree[idx].lazy.h2<<endl;
        cout<<tree[idx].all_equal<<endl;
        if(l==r)return;
        print(l,(l+r)/2,idx*2);
        print((l+r)/2+1,r,idx*2+1);
    }
}t;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    srand(231232);
    sieve();
    //cout<<"?\n";
    random_shuffle(primes.begin(),primes.end());
    for(int i=0;i<MAXN;i++)b1[i]=primes[i];
    random_shuffle(primes.begin(),primes.end());
    for(int i=0;i<MAXN;i++)b2[i]=primes[i];
    random_shuffle(primes.begin(),primes.end());
    for(int i=0;i<MAXN;i++)b3[i]=primes[i];
    random_shuffle(primes.begin(),primes.end());
    for(int i=0;i<MAXN;i++)b4[i]=primes[i];
    //cout<<"??\n";
    cin>>n>>q;
    //cout<<"^\n";
    t.build(1,n,1);
    //cout<<"&\n";
    for(int i=0;i<q;i++)
    {
        int type;
        cin>>type;
        if(type==1)
        {
            int l,r,x;
            cin>>l>>r>>x;
            t.update(1,n,l,r,1,x);
        }
        else
        {
            int l,r;
            cin>>l>>r;
            cout<<t.query(l,r)<<endl;
        }
        //t.print(1,n,1);
    }
return 0;
}
/*
10000000069
10000000097
10000000103
10000000121
*/
