#include<iostream>
#include<vector>
#include "periods.h"
using namespace std;

typedef long long ll;

/*
ll a[100];

bool hasPeriod(ll len,ll per){
  for(ll i=per;i<len;++i)if(a[i]!=a[i-per])return 0;
  return 1;
  }
*/

std::vector<int> findPeriods(int n){
  vector<int> ans(n);
  bool xd[n+1];

  for(ll i=0;i<n;++i)ans[i]=0;

  xd[1]=1;
  for(ll i=2;i<=n;++i){
    xd[i]=0;
    if(hasPeriod(i,i-1))xd[i]=1;
    }

  ans[0]=1;
  for(ll i=2;i<=n;++i){
    if(xd[i]){
      for(ll j=i;j<=n;j+=(i-1)){
        if(ans[j-1] || !xd[j])break;
        ans[j-1]=i-1;
        }
      }
    }

  for(ll i=2;i<=n;++i){
    if(!ans[i-1]){
      ans[i-1]=ans[i];
      }
    }

  for(ll i=2;i<=n;++i){
    if(!xd[i-ans[i-1]])ans[i-1]=i;
    }

  return ans;
  }


/*

int main(){

ll n;
cin>>n;
for(ll i=0;i<n;++i)cin>>a[i];
vector<int> cock=findPeriods(n);

for(ll i : cock)cout<<i<<" ";cout<<endl;

return 0;
}
/*
3
0 0 1
*/
