#include<bits/stdc++.h>
#define endl '\n'
#define mspp multiset<pair<int, pair<int, int>>>
#define beginBorder -1
#define endBorder 1
#define D(x) cerr << "at " << __LINE__ << #x << " = " << (x) << endl;
using namespace std;

const int MAXV = 1e+5+1;
int cocktailsCount, queriesCount, qType;
// node : pair<int position, pair<int typeBorder, int typeDrink>>

mspp borders;

void AddDrink(int l, int r, int type)
{
    // Collapsing closing border
    mspp::iterator borderToCollapse = borders.find({l, {endBorder, type}});
    pair<int, pair<int, int>> borderToCollapseValue;
    if(borderToCollapse != borders.end())
    {
        borderToCollapseValue = *borderToCollapse;
        borders.erase(borderToCollapseValue);
    }
    else borders.insert({l, {beginBorder, type}});

    // Collapsing begin border
    borderToCollapse = borders.find({r, {beginBorder, type}});
    if(borderToCollapse != borders.end())
    {
        borderToCollapseValue = *borderToCollapse;
        borders.erase(borderToCollapseValue);
    }
    else borders.insert({r, {endBorder, type}});
}

bool QuestionBorder(int l, int r)
{
    mspp::iterator begBorder = borders.insert({l, {0, 0}});
    mspp::iterator enBorder = borders.insert({r, {0, 0}});
    if(distance(begBorder, enBorder) == 1)
        return true;
    return false;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    cin >> cocktailsCount >> queriesCount;
    int data[3];
    for(int i = 0; i < queriesCount; i++)
    {
        cin >> qType;
        if(qType == 1)
        {
            cin >> data[0] >> data[1] >> data[2];
            AddDrink(data[0], data[1], data[2]);
        }
        else
        {
            cin >> data[0] >> data[1];
            cout << (QuestionBorder(data[0], data[1])?1:0) << endl;
        }
    }
    return 0;
}
// lower_bound -> first greater or equal
// upper_bound -> first greater
