#include<bits/stdc++.h>
#define endl '\n'
#define mspp multiset<pair<int, pair<int, int>>>
#define beginBorder -1
#define endBorder 1
#define D(x) cerr << "at " << __LINE__ << #x << " = " << (x) << endl;
using namespace std;

int cocktailsCount, queriesCount, qType;
mspp borders;

void AddDrink(int l, int r, int type)
{
    // Collapsing closing border
    mspp::iterator borderToCollapse = borders.find({l-1, {endBorder, type}});
    if(borderToCollapse != borders.end())
        borders.erase(borderToCollapse);
    else borders.insert({l, {beginBorder, type}});

    // Collapsing begin border
    borderToCollapse = borders.find({r+1, {beginBorder, type}});
    if(borderToCollapse != borders.end())
        borders.erase(borderToCollapse);
    else borders.insert({r, {endBorder, type}});
}

bool QuestionBorder(int l, int r)
{
    bool retValue = false;
    mspp::iterator begBorder = borders.insert({l, {0, 0}});
    mspp::iterator enBorder = borders.insert({r, {0, 0}});
    //cout << "DIST " << distance(begBorder, enBorder) << endl;
    if(distance(begBorder, enBorder) == 1)
        retValue = true;
    borders.erase(begBorder);
    borders.erase(enBorder);
    return retValue;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    cin >> cocktailsCount >> queriesCount;
    int data[3];
    for(int i = 0; i < queriesCount; i++)
    {
        cin >> qType;
        if(qType == 1)
        {
            cin >> data[0] >> data[1] >> data[2];
            AddDrink(data[0], data[1], data[2]);
        }
        else
        {
            cin >> data[0] >> data[1];
            cout << (QuestionBorder(data[0], data[1])?1:0) << endl;
        }
    }
    for(pair<int, pair<int, int>> e : borders)
        cout << e.first << " " << e.second.first << " " << e.second.second << endl;
    return 0;
}

// lower_bound -> first greater or equal
// upper_bound -> first greater
