#include<bits/stdc++.h>
#include "periods.h"
using namespace std;

const int MAXN = 100000;

int FindSmallestPeriod(int minValue, int maxValue, int len)
{
    // Biggest period that the current prefix has not.
    int left = minValue;
    // Smallest period that the current prefix has.
    int right = maxValue, mid;
    while(left < right-1)
    {
        mid = (left+right)/2;
        if(hasPeriod(len, mid)) right = mid;
        else left = mid;
    }
    return right;
}

vector<int> findPeriods(int n)
{
    vector<int> returnValue;
    returnValue.push_back(1);
    for(int prefix = 2; prefix <= n; prefix++)
        returnValue.push_back(FindSmallestPeriod(1, prefix, prefix));
    return returnValue;
}
