#include <vector>

bool hasPeriod(int len, int period);
std::vector<int> findPeriods(int n);

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
typedef long long ll;
const ll mod = 1e9 + 7;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const int MAX_N = 1e5 + 10;
int ed[MAX_N];

std::vector<int> findPeriods(int n) {
    std::vector<int> ret;
    for(int i = 0; i <= n; i ++) {
        ret.push_back(i);
    }
    for(int i = 1; i <= n; i ++) {
        ed[i] = n / i;
    }
    for(int x = n / 2; x >= 1; x --) {
        for(int y = x * 2; y <= n / 2; y += x) {
            int z = y / x;
            chkmin(ed[x], (ed[y] + 1) * z);
        }
        int l = 1, r = ed[x];
        if(hasPeriod(r * x, x)) {
            for(int i = x; i <= n; i += x) {
                chkmin(ret[i], x);
            }
        } else {
            while(l < r - 1) {
                int m = (l + r) / 2ll;
                if(hasPeriod(m * x, x)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            for(int i = x; i <= l * x; i += x) {
                chkmin(ret[i], x);
            }
            ed[x] = r;
        }
    }
    reverse(ret.begin(), ret.end());
    ret.pop_back();
    reverse(ret.begin(), ret.end());
    return ret;
}
