#include <iostream>
#include <vector>
#include "periods.h"
using namespace std;

vector<int> findPeriods(int n)
{
    vector<int> ans;
    ans.resize(n, -1);
    int curr = 2; int k = 1;
    ans[0] = 1;
    for(k = 1; k <= n; k++){
        for(int j = 1; k*j <= n; j++){
            if(k*j == 1) continue;
            if(ans[k*j-1] != -1) continue;
            if(hasPeriod(j*k ,k)){
                ans[k*j-1] = k;
            }else{
                break;
            }
        }
    }
    return ans;
}
