#include<iostream>
#include "periods.h"
using namespace std;

vector<int> findPeriods(int n)
{
    vector<int> v;

    for(int i=1; i<=n; i++)
    {
        int from=1, to=n;
        while(true)
        {
            if(from==to)
            {
                v.push_back(from);
                break;
            }
            else if(from+1==to)
            {
                if(hasPeriod(i, from))
                {
                    v.push_back(from);
                }
                else
                {
                    v.push_back(to);
                }
                
                break;
            }
            
            int mid=(from+to)/2;
            if(hasPeriod(i, mid))
            {
                to=mid;
            }
            else
            {
                from=mid+1;
            }
        }
    }

    return v;
}
