#include<iostream>
#include<deque>
#include "periods.h"
using namespace std;

vector<int> findPeriods(int n)
{
    deque<int> periods;
    for(int i=1; i<=n; i++)
    {
        periods.push_back(i);
    }

    vector<int> v;

    for(int i=1; i<=n; i++)
    {
        if(periods.front()>=i)
        {
            periods.push_front(i);
        }

        while(!hasPeriod(i, periods.front()))
        {
            periods.pop_front();

            if(periods.front()>=i)
            {
                periods.push_front(i);
                break;
            }
        }

        v.push_back(periods.front());
    }

    return v;
}
