#include<iostream>
#include<algorithm>
#include "periods.h"
using namespace std;

const int MAXN=1e5;
vector<int> dividers[MAXN+1];

vector<int> findPeriods(int n)
{
    vector<int> v;
    v.push_back(1);

    for(int i=2; i<=n; i++)
    {
        dividers[i].push_back(1);
    }

    for(int i=2; i<=n; i++)
    {
        for(int j=i; j<=n; j+=i)
        {
            dividers[j].push_back(i);
        }

        int from=0, to=dividers[i].size();
        while(true)
        {
            if(from==to)
            {
                break;
            }

            if(from+1==to)
            {
                if(hasPeriod(i, dividers[i][from]))
                {
                    break;
                }

                from=to;

                break;
            }

            int mid=(from+to)/2;
            if(hasPeriod(i, dividers[i][mid]))
            {
                to=mid;
            }
            else
            {
                from=mid+1;
            }
        }

        v.push_back(dividers[i][from]);
    }

    return v;
}
