#include <bits/stdc++.h>

const int MAXN = 2e5 + 10, INF = 1e9;

int lazy[4 * MAXN];

std::pair<int, int> tree[4 * MAXN];

std::pair<int, int> update(int ind, int tl, int tr, int ql, int qr, int val)
{
    //std::cout << ind << ' ' << tl << ' ' << tr << '\t';
    if(ql >= tr || qr <= tl)
    {
        //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return {tree[ind].first + lazy[ind] * (tr - tl), tree[ind].second + lazy[ind] * (tr - tl)};
    }

    if(tl == tr - 1)
    {
        tree[ind].first += lazy[ind];
        tree[ind].first += val;
        tree[ind].second += lazy[ind];
        tree[ind].second += val;
        lazy[ind] = 0;

        //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return tree[ind];
    }

    if(tl >= ql && tr <= qr)
    {
        lazy[ind] += val;

        //std::cout << "alalal" << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return {tree[ind].first + lazy[ind] * (tr - tl), tree[ind].first + lazy[ind] * (tr - tl)};
    }

    //tree[ind] += lazy[ind] * (tr - tl);
    lazy[ind * 2] += lazy[ind];
    lazy[ind * 2 + 1] += lazy[ind];
    lazy[ind] = 0;

    auto left = update(ind * 2, tl, (tl + tr) / 2, ql, qr, val);
    auto right = update(ind * 2 + 1, (tl + tr) / 2, tr, ql, qr, val);

    tree[ind] = {std::min(left.first, right.first), std::max(left.second, right.second)};

    //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
    return tree[ind];
}

std::pair<int, int> calc(int ind, int tl, int tr, int ql, int qr)
{
    if(ql >= tr || qr <= tl)
    {
        //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return {INF, 0};
    }

    if(tl == tr - 1)
    {
        tree[ind].first += lazy[ind];
        tree[ind].second += lazy[ind];
        lazy[ind] = 0;

        //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return tree[ind];
    }

    if(tl >= ql && tr <= qr)
    {
        tree[ind].first += lazy[ind] * (tr - tl);
        tree[ind].second += lazy[ind] * (tr - tl);
        lazy[ind * 2] += lazy[ind];
        lazy[ind * 2 + 1] += lazy[ind];
        lazy[ind] = 0;

        //std::cout << "alalal" << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
        return tree[ind];
    }

    lazy[ind * 2] += lazy[ind];
    lazy[ind * 2 + 1] += lazy[ind];
    lazy[ind] = 0;

    auto left = calc(ind * 2, tl, (tl + tr) / 2, ql, qr);
    auto right = calc(ind * 2 + 1, (tl + tr) / 2, tr, ql, qr);

    tree[ind] = {std::min(left.first, right.first), std::max(left.second, right.second)};

    //std::cout << ind << ' ' << lazy[ind] << ' ' << tree[ind] << '\n';
    return tree[ind];
}

int main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int n, q;
    std::cin >> n >> q;

    for(int i = 0; i < q; ++ i)
    {
        int cq;
        std::cin >> cq;
        if(cq == 1)
        {
            int a, b, c;
            std::cin >> a >> b >> c;
            -- a;
            -- b;

            update(1, 0, n, a, b + 1, 1);
        }else
        {
            int a, b;
            std::cin >> a >> b;
            -- a;
            -- b;

            auto ch = calc(1, 0, n, a, b + 1);
            std::cout << (bool)(ch.first == ch.second) << '\n';
        }
    }

    return 0;
}
