#include<bits/stdc++.h>
#pragma GCC optimize "Ofast"
#pragma GCC target "avx"
#pragma GCC target "avx2"
#define min(a,b) a<b?a:b;
#define max(a,b) a>b?a:b;
using namespace std;
vector<long long>primes;
long long mod=2000000011;
long long k;
struct node
{
    long long isequal=1;
    long long lp=1;
};
vector<node>tree;
void doprimes()
{
    long long n;
    n=1700000;
    vector<long long>used(n+1,0);
    long long t=clock();
    for(long long i=2; i<=n; i++)
    {
        if(!used[i])
        {
            primes.push_back(i);
            for(long long j=i; i*j<=n; j++)
            {
                used[i*j]=1;
            }
        }
    }
}
void update(long long beg,long long en,long long val,long long current=1,long long l=0,long long r=k-1)
{
    tree[current].lp*=tree[current/2].lp;
    tree[current].lp%=mod;
    if(tree[current].isequal!=-1)tree[current].isequal*=tree[current/2].lp;
    if(tree[current].isequal!=-1)tree[current].isequal%=mod;
    if(r<beg)
    {
        return ;
    }
    else if(l>en)return;
    else if(beg<=l && r<=en)
    {
        tree[current].lp*=val;
        tree[current].isequal%=mod;
        if(tree[current].isequal!=-1)tree[current].isequal*=val;
        tree[current].isequal%=mod;
        return;
    }
    else
    {
        update(beg,en,val,current*2,l,(l+r)/2);
        update(beg,en,val,current*2+1,(l+r)/2+1,r);
        tree[current].lp=1;
        if(tree[current*2].isequal==tree[current*2+1].isequal && tree[current*2+1].isequal!=-1)tree[current].isequal=tree[current*2].isequal;
        else tree[current].isequal=-1;
    }
}
bool ask(long long val,long long beg,long long en,long long current=1,long long l=0,long long r=k-1)
{
    tree[current].lp*=tree[current/2].lp;
    tree[current].lp%=mod;
    if(tree[current].isequal!=-1)tree[current].isequal*=tree[current/2].lp;
    if(tree[current].isequal!=-1)tree[current].isequal%=mod;
    if(r<beg)return 1;
    else if(l>en)return 1;
    else if(beg<=l && r<=en)
    {
        if(tree[current].isequal==val)return 1;
        else return 0;
    }
    else
    {
        bool x=ask(val,beg,en,current*2,l,(l+r)/2);
        x=x&&ask(val,beg,en,current*2+1,(l+r)/2+1,r);
        tree[current].lp=1;
        return x;
    }
}
long long askforelement(long long x,long long current=1,long long l=0,long long r=k-1)
{
    tree[current].lp*=tree[current/2].lp;
    tree[current].lp%=mod;
    if(tree[current].isequal!=-1)tree[current].isequal*=tree[current/2].lp;
    if(tree[current].isequal!=-1)tree[current].isequal%=mod;
    if(x<l || x>r)return 1;
    else if(x==l && x==r)return tree[current].isequal;
    long long t=askforelement(x,current*2,l,(l+r)/2)*askforelement(x,current*2+1,(l+r)/2+1,r);
    tree[current].lp=1;
    return t;
}
int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    long long n,q;
    doprimes();
    cin>>n>>q;
    k=1;
    while(k<n)k<<=1;
    tree.resize(k*2);
    for(long long as=0; as<q; as++)
    {
        long long c;
        cin>>c;
        if(c==1)
        {
            long long l,r,x;
            cin>>l>>r>>x;
            l--;
            r--;
            update(l,r,primes[x]);
            /*cout<<"////"<<endl;
            for(long long i=1;i<k*2;i++)
            {
                cout<<i<<' '<<tree[i].isequal<<' '<<tree[i].lp<<endl;
            }
            cout<<"****"<<endl;*/
        }
        else
        {
            long long l,r;
            cin>>l>>r;
            l--;
            r--;
            long long shit=askforelement(l);
            if(ask(shit,l,r))
                cout<<1<<endl;
            else
                cout<<0<<endl;
        }
    }
    return 0;
}
