#include<bits/stdc++.h>

using namespace std;

const int nmax=200010;
int timer;
vector<int> v[nmax];
pair<int, int> tree[4*nmax];
bool lazy[4*nmax];
int m[nmax];

void push(int root)
{
    if(lazy[root])
    {
        tree[root*2].first=tree[root*2].second=tree[root*2+1].first=tree[root*2+1].second=tree[root].first;
        lazy[root*2]=lazy[root*2+1]=lazy[root];
        lazy[root]=0;
    }
}

pair<int, int> query(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return tree[root];
    push(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query(root*2, l, mid, ql, qr);
    if(ql>mid) return query(root*2+1, mid+1, r, ql ,qr);
    pair<int, int> i1=query(root*2, l, mid, ql, mid);
    pair<int, int> i2=query(root*2+1, mid+1, r, mid+1, qr);
    i1.first=max(i1.first, i2.first);
    i1.second=min(i1.second, i2.second);
    return i1;
}

void update(int root, int l, int r, int ql, int qr, int x)
{
    //cout<<root<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<endl;
    if(l==ql&&r==qr)
    {
        tree[root].first=tree[root].second=x;
        lazy[root]=1;
    }
    else
    {
        push(root);
        int mid=(l+r)/2;
        if(qr<=mid) update(root*2, l, mid, ql, qr, x);
        else if(ql>mid) update(root*2+1, mid+1, r, ql, qr, x);
        else
        {
            update(root*2, l, mid, ql, mid, x);
            update(root*2+1, mid+1, r, mid+1, qr, x);
        }
        tree[root].first=max(tree[root*2].first, tree[root*2+1].first);
        tree[root].second=min(tree[root*2].second, tree[root*2+1].second);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, q, type, x, l, r;
    cin>>n>>q;
    if(n<=3000)
    {
        for(int i=1; i<=n; ++i)
            for(int j=0; j<=3000; ++j) v[i].push_back(0);
        while(q--)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                if(m[x]==0) m[x]=++timer;
                int id=m[x];
                for(int i=l; i<=r; ++i)
                {
                    v[i][id]++;
                }
            }
            else
            {
                int lamp=0;
                cin>>l>>r;
                for(int i=l+1; i<=r; ++i) if(v[l]!=v[i])
                {
                    lamp=1;
                    break;
                }
                if(lamp==1) cout<<0<< endl;
                else cout<<1<< endl;
            }
        }
        return 0;
    }
    if(n>500)
    {
        while(q--)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                update(1, 1, n, l, r, x);
            }
            else
            {
                cin>>l>>r;
                pair<int, int> d=query(1, 1, n, l, r);
                if(d.first==d.second) cout<<1<< endl;
                else cout<<0<< endl;
            }
        }
        return 0;
    }
    while(q--)
    {
        cin>>type;
        if(type==1)
        {
            cin>>l>>r>>x;
            for(int i=l; i<=r; ++i) v[i].push_back(x);
        }
        else
        {
            cin>>l>>r;
            bool lamp=0;
            for(int i=l; i<=r; ++i) sort(v[i].begin(), v[i].end());
            for(int i=l+1; i<=r; ++i) if(v[i]!=v[l])
            {
                lamp=1;
                break;
            }
            if(lamp==1) cout<<0<< endl;
            else cout<<1<< endl;
        }
    }
    return 0;
}
/*
4 7
2 1 3
1 1 3 5
1 3 4 5
2 1 3
2 1 2
1 2 2 5
2 1 2

*/
