#include<iostream>
#include<bits/stdc++.h>
using namespace std;
int n,q;
int a[501][100002];
int td[100010];
int query_type[200001];
int query_l[200001];
int query_r[200001];
int t_c[200001];
int lamp=0;
void query1(int l, int r, int x)
{
    for(int i=l; i<=r; i++)
    {
        a[i][x]+=1;
    }
}
int query2(int l, int r)
{
    memset(td,0,sizeof(td));
    for(int i=1; i<=100001; i++)
    {
        td[i]=a[l][i];
    }
    for(int i=l+1; i<=r; i++)
    {
        for(int j=1; j<=100001; j++)
        {
            if(a[i][j]!=td[j])
                return 0;
        }
    }
    return 1;
}
void read()
{
    cin>>n>>q;
    for(int i=1; i<=q; i++)
    {
        int type;
        cin>>type;
        if(type==1)
        {
            int tl,tr,tx;
            cin>>tl>>tr>>tx;
            query_type[i]=tx;
            query_l[i]=tl;
            query_r[i]=tr;
            if(tx!=1) lamp=1;
        }
        else
        {
            int tl,tr;
            cin>>tl>>tr;
            query_type[i]=0;
            query_l[i]=tl;
            query_r[i]=tr;
        }
    }
    return;
}
pair<bool,int>tree[800008];
int lazy[800008];
void make_tree(int i, int l, int r)
{
    if(l==r)
    {
        tree[i].first=1;
        tree[i].second=0;
        return;
    }
    int m=(l+r)/2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i].first=1;
    tree[i].second=0;
    return;
}
void push_lazy(int i)
{
    if(lazy[i]!=0)
    {
        lazy[i*2]+=lazy[i];
        lazy[i*2+1]+=lazy[i];
        return;
    }
}
void update_lazy(int i, int l, int r, int ql, int qr)
{
    push_lazy(i);
    if(l==ql && r==qr)
    {
        if(tree[i].first==1)
        {
            tree[i].second+=lazy[i];
            lazy[i]=0;
        }
        lazy[i]=0;
        return;
    }
    int m=(l+r)/2;
    if(qr<=m) {update_lazy(i*2,l,m,ql,qr);return;}
    if(ql>m) {update_lazy(i*2+1,m+1,r,ql,qr);return;}
    update_lazy(i*2,l,m,ql,m);
    update_lazy(i*2+1,m+1,r,m+1,qr);
    if(tree[i*2].first==1 && tree[i*2+1].first==1)
    {
        if(tree[i*2].second==tree[i*2+1].second)
        {
            tree[i].first=1;
            tree[i].second=tree[i*2].second;
        }
        else
        {
            tree[i].first=0;
        }
    }
    return;
}
int query_tree(int i, int l, int r, int ql, int qr)
{
    push_lazy(i);
    if(lazy[i]!=0)
    {
        if(tree[i].first==1)
        {
            tree[i].second+=lazy[i];
            lazy[i]=0;
        }
        lazy[i]=0;
    }
    if(l==ql && r==qr) return tree[i].first;
    int m=(l+r)/2;
    if(qr<=m) return query_tree(i*2,l,m,ql,qr);
    if(ql>m) return query_tree(i*2+1,m+1,r,ql,qr);
    if(tree[i*2].first==1 && tree[i*2+1].first==1)
    {
        if(tree[i*2].second==tree[i*2+1].second)
        {
            tree[i].first=1;
            tree[i].second=tree[i*2].second;
            return 1;
        }
        else
        {
           tree[i].first=0;
           return 0;
        }
    }
    return 0;
}
void solve()
{
    make_tree(1,1,n);
    if(lamp==1)
    {
        for(int i=1; i<=q; i++)
        {
            if(query_type[i]==0)
            {
                cout<<query2(query_l[i],query_r[i])<<endl;
            }
            else
            {
                query1(query_l[i],query_r[i],query_type[i]);
            }
        }
    }
    else
    {
        for(int i=1; i<=q; i++)
        {
            if(query_type[i]==0)
            {
               cout<<query_tree(1,1,n,query_l[i],query_r[i])<<endl;
            }
            else
            {
               update_lazy(1,1,n,query_l[i],query_r[i]);
            }
        }
    }
}
int main()
{
    read();
    solve();
    return 0;
}
