#include <iostream>
using namespace std;
int n, q;
const int MAXN = 1e6;
int t[4*MAXN];
void make_tree(int i, int l, int r)
{
    if(l==r)t[i] = -1;
    else{
        int m = (l+r)/2;
        make_tree(2*i, l, m);
        make_tree(2*i+1, m+1, r);
        t[i] = -1;
    }
}
void up(int i, int l, int r, int idx, int val)
{
    if(l==idx&&r==idx)
    {
        t[i] = val;
        /*cout<<i<<endl;
        cout<<l<<endl;
        for(int j=1;j<=2*n;j++)
           {
               cout<<t[j]<<" ";
           }
           cout<<endl;*/
        return;
    }
        int m = (l+r)/2;
        if(idx<=m)up(2*i, l, m, idx, val);
        else
        {
            up(2*i+1, m+1, r, idx, val);
        }
        if(t[2*i]==0||t[2*i+1]==0)t[i] = 0;
        if(t[2*i]==t[2*i+1]&&t[2*i]!=0)t[i] = -1;
        if(t[2*i]!=t[2*i+1])t[i] = 0;

}
int query(int i, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr)return t[i];
    {
        int m = (l+r)/2;
        if(qr<=m)return query(2*i, l, m, ql, qr);
        else if(ql>m)return query(2*i+1, m+1, r, ql, qr);
        else{
            int x = query(2*i, l, m, ql, m);
            int y = query(2*i+1, m+1, r, m+1, qr);
            //cout<<x<<" "<<y<<endl;
            if(x==0||y==0)return 0;
            else if(x!=y)return 0;
            else if(x==y)return -1;
        }
    }
}
int main()
{
    cin>>n>>q;
    int d;
    make_tree(1, 1, n);
    int x, l, r;
    for(int i=1;i<=q;i++)
    {
        cin>>d;
        if(d==1)
        {
           cin>>l>>r>>x;
           for(int j=l;j<=r;j++)
           {
               up(1, 1, n, j, x);
           }
           /*for(int j=1;j<=2*n;j++)
           {
               cout<<t[j]<<" ";
           }*/
        }
        else{
            cin>>l>>r;
            int f = query(1, 1, n, l, r);
            if(f==-1)cout<<1<<endl;
            else cout<<0<<endl;
        }
    }
    return 0;
}
