#include <iostream>
using namespace std;
long long n, q;
const long long MAXN = 1e6;
long long t[4*MAXN];
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
void make_tree(long long i, long long l, long long r)
{
    if(l==r)t[i] = 0;
    else{
        long long m = (l+r)/2;
        make_tree(2*i, l, m);
        make_tree(2*i+1, m+1, r);
        t[i] = 0;
    }
}
void up(long long i, long long l, long long r, long long idx, long long val)
{
    if(l==idx&&r==idx)
    {
        t[i] ++;
        /*cout<<i<<endl;
        cout<<l<<endl;
        for(long long j=1;j<=2*n;j++)
           {
               cout<<t[j]<<" ";
           }
           cout<<endl;*/
        return;
    }
        long long m = (l+r)/2;
        if(idx<=m)up(2*i, l, m, idx, val);
        else
        {
            up(2*i+1, m+1, r, idx, val);
        }
        if(t[2*i]==t[2*i+1])t[i] = 1;
        else t[i] = -1;

}
long long query(long long i, long long l, long long r, long long ql, long long qr)
{
    if(l==ql&&r==qr)return t[i];
    {
        long long m = (l+r)/2;
        if(qr<=m)return query(2*i, l, m, ql, qr);
        else if(ql>m)return query(2*i+1, m+1, r, ql, qr);
        else{
            long long x = query(2*i, l, m, ql, m);
            long long y = query(2*i+1, m+1, r, m+1, qr);
            //cout<<x<<" "<<y<<endl;
            if(x==y)return 1;
            else return -1;
        }
    }
}
int main()
{
    speed();
    cin>>n>>q;
    long long d;
    make_tree(1, 1, n);
    long long x, l, r;
    for(long long i=1;i<=q;i++)
    {
        cin>>d;
        if(d==1)
        {
           cin>>l>>r>>x;
           for(long long j=l;j<=r;j++)
           {
               up(1, 1, n, j, x);
           }
           /*for(long long j=1;j<=2*n;j++)
           {
               cout<<t[j]<<" ";
           }*/
        }
        else{
            cin>>l>>r;
            long long f = query(1, 1, n, l, r);
            if(f==-1)cout<<0<<endl;
            else cout<<1<<endl;
        }
    }
    return 0;
}