#include <bits/stdc++.h>
using namespace std;

const int maxn = 200005;
int n, q;

pair <bool, map <int, int> > tree [4 * maxn];
map <int, int> lazy [4 * maxn];
void upd_lazy (int l, int r, int pos){
    for (auto p : lazy [pos]) tree [pos].second [p.first] += p.second;
    if (l == r) return;
    for (auto p : lazy [pos]){
        lazy [pos << 1][p.first] += p.second;
        lazy [pos << 1 | 1][p.first] += p.second;
    }
}
void update (int l, int r, int pos, int ql, int qr, int x){
    upd_lazy (l, r, pos);
    if (ql <= l && r <= qr){
        lazy [pos][x] ++;
        upd_lazy (l, r, pos);
        return;
    }
    if (l > qr || r < ql) return;
    int mid = l + r >> 1;
    update (l, mid, pos << 1, ql, qr, x);
    update (mid + 1, r, pos << 1 | 1, ql, qr, x);
    if (tree [pos << 1].first || tree [pos << 1 | 1].first || tree [pos << 1].second != tree [pos << 1 | 1].second) tree [pos].first = 1;
    else{
        tree [pos].first = 0;
        tree [pos].second = tree [pos << 1].second;
    }
}
pair <bool, map <int, int> > query (int l, int r, int pos, int ql, int qr){
    upd_lazy (l, r, pos);
    if (ql <= l && r <= qr) return tree [pos];
    if (l > qr || r < ql) return {0, {{-1, 1}}};
    int mid = l + r >> 1;
    auto q1 = query (l, mid, pos << 1, ql, qr), q2 = query (mid + 1, r, pos << 1 | 1, ql, qr);
    if (q1.first || q2.first) return {1, {}};
    if (q1.second [-1] == 1) return q2;
    if (q2.second [-1] == 1) return q1;
    if (q1.second == q2.second) return q1;
    return {1, {}};
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> q;
    while (q --){
        int t, l, r, x;
        cin >> t >> l >> r;
        if (t == 1){
            cin >> x;
            update (1, n, 1, l, r, x);
        }
        else{
            auto q = query (1, n, 1, l, r);
            cout << !q.first << '\n';
        }
    }

}
