#include <bits/stdc++.h>
//#include "periods.h"
using namespace std;

bool hasPeriod (int len, int period);

const int maxn = 100005;
int n;
int periods [maxn];

vector <int> findPeriods (int n){
    for (int i = 1; i <= n >> 1; i ++){
        if (periods [i]) continue;
        if (!hasPeriod (2 * i, i)) continue;
        int l = 2, r = n / i;
        if (r - l <= 1){
            while (l < r){
                int mid = l + r + 1 >> 1;
                if (hasPeriod (mid * i, i)) l = mid;
                else r = mid - 1;
            }
        }
        else{
            l ++;
            while (l <= r && hasPeriod (l * i, i)) l ++;
            l --;
        }
        for (int j = 2; j <= l; j ++){
            if (!periods [i * j]) periods [i * j] = i;
        }
    }
    vector <int> ans;
    for (int i = 1; i <= n; i ++){
        if (periods [i]) ans.push_back (periods [i]);
        else ans.push_back (i);
    }
    return ans;
}