#include <bits/stdc++.h>
#include "periods.h"

using namespace std;

vector <int> get_divisors(int n)
{
    vector <int> ans;
    for (int i = 2; 1ll * i * i <= n; i++)
    if (n % i == 0)
    {
        ans.push_back(i);
        if (1ll * i * i != n)
        ans.push_back(n / i);
    }

    ans.push_back(1);
    sort (ans.begin(), ans.end());
    return ans;
}

vector <int> findPeriods(int n)
{
    vector <int> ans;
    ans.resize(n);

    ans[0] = 1;
    for (int i = 2; i <= n; i++)
    {
        vector <int> d = get_divisors(i);
        ans[i-1] = i;

        for (auto j: d)
        {
            bool is = true;
            for (int k = 1; k < i / j; k++)
            if (j % ans[i - k * j - 1] != 0)
            {
                is = false;
                break;
            }

            if (is && hasPeriod(i, j))
            {
                ans[i-1] = j;
                break;
            }
        }

    }

    return ans;
}
