#include <bits/stdc++.h>
#include "periods.h"

using namespace std;

vector <int> get_divisors(int n)
{
    vector <int> ans;
    for (int i = 2; 1ll * i * i <= n; i++)
    if (n % i == 0)
    {
        ans.push_back(i);
        if (1ll * i * i != n)
        ans.push_back(n / i);
    }

    ans.push_back(1);
    sort (ans.begin(), ans.end());
    return ans;
}

vector <int> findPeriods(int n)
{
    vector <int> ans(n, 0);
    vector <bool> is(n+1, true);

    for (int i = 1; i <= min(n, 10); i++)
    {
        int low = 1, high = n / i;
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (ans[mid * i - 1])
            {
                if (i % ans[mid * i - 1] == 0)
                low = mid;

                else
                high = mid-1;
            }

            else
            {
                if (hasPeriod(mid * i, i))
                    low = mid;

                else
                    high = mid - 1;
            }
        }

        for (int j = 1; j <= low; j++)
        if (!ans[j * i - 1])
        ans[j * i - 1] = i;

        is[i] = false;
    }

    for (int i = 1; i <= n; i++)
    {
        if (ans[i-1] != 0)
            continue;

        vector <int> d = get_divisors(i);
        ans[i-1] = i;

        for (auto j: d)
        {
            if (!is[j])
            continue;

            if (hasPeriod(i, j))
            {
                ans[i-1] = j;
                break;
            }
        }

        for (auto j: d)
        if (j % ans[i-1] != 0)
        is[j] = false;
    }

    return ans;
}
