#include <bits/stdc++.h>
#include "periods.h"

using namespace std;

vector <int> get_divisors(int n)
{
    vector <int> ans;
    for (int i = 2; 1ll * i * i <= n; i++)
    if (n % i == 0)
    {
        ans.push_back(i);
        if (1ll * i * i != n)
        ans.push_back(n / i);
    }

    ans.push_back(1);
    sort (ans.begin(), ans.end());
    return ans;
}

vector <int> findPeriods(int n)
{
    vector <int> ans(n, 0);
    vector <bool> is(n+1, true);

    for (int i = 1; i <= n / 2; i++)
    {
        is[i] = false;

        vector <int> all;
        for (int j = i; j <= n; j += i)
        if (!ans[j-1])
        all.push_back(j);

        if (all.empty())
            continue;

        if (!hasPeriod(all[0], i))
            continue;

        int low = 0, high = (int)all.size() - 1;
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (hasPeriod(all[mid], i))
            low = mid;

            else
            high = mid - 1;
        }

        for (int j = 0; j <= low; j++)
        ans[all[j] - 1] = i;

    }

    for (int i = 1; i <= n; i++)
    {
        if (ans[i-1])
            continue;

        vector <int> d = get_divisors(i);
        ans[i-1] = i;

        for (auto j: d)
        {
            if (!is[j])
            continue;

            bool can_c = true;
            for (int p = i - j + 1; p < i; p++)
            if (j % ans[p-1] != 0)
            {
                can_c = false;
                break;
            }

            if (!can_c)
                continue;

            if (hasPeriod(i, j))
            {
                ans[i-1] = j;
                break;
            }
        }

        for (auto j: d)
        if (j % ans[i-1] != 0)
        is[j] = false;
    }

    return ans;
}
