#include <bits/stdc++.h>
#include "periods.h"

using namespace std;

vector <int> get_divisors(int n)
{
    vector <int> ans;
    for (int i = 2; 1ll * i * i <= n; i++)
    if (n % i == 0)
    {
        ans.push_back(i);
        if (1ll * i * i != n)
        ans.push_back(n / i);
    }

    ans.push_back(1);
    sort (ans.begin(), ans.end());
    return ans;
}

vector <int> findPeriods(int n)
{
    vector <int> ans(n, 0);
    vector <bool> is(n+1, true);

    for (int i = 2; 1ll * i * i <= n; i++)
    {
        if (ans[i])
            continue;

        int curr = 1;
        long long temp = i;

        while (temp <= n)
        {
            while (curr < temp && !hasPeriod(temp, curr))
                curr *= i;

            ans[temp] = curr;
            temp *= (long long)i;
        }
    }

    ans[0] = 1;
    for (int i = 1; i <= n; i++)
    {
        vector <int> d = get_divisors(i);
        if (ans[i-1] != 0)
        {
            for (auto j: d)
            if (j % ans[i-1] != 0)
            is[j] = false;
            continue;
        }

        ans[i-1] = i;
        for (auto j: d)
        {
            if (!is[j])
            continue;

            if (hasPeriod(i, j))
            {
                ans[i-1] = j;
                break;
            }
        }

        for (auto j: d)
        if (j % ans[i-1] != 0)
        is[j] = false;
    }

    return ans;
}
