#include<bits/stdc++.h>
using namespace std;

const int mn = 2e5 + 4;
int n, q;
long long tmin[mn<<2], lazymin[mn<<2];
long long t[mn<<2], lazy[mn<<2];


unsigned long long fpow(int p)
{
    p+=5ll;
    unsigned long long x = 2, ans = 1;
    while(p > 0){
        if(p & 1){
            ans *= x;
        }
        x*=x;
        p >>= 1;
    }
     return ans+1ull;
}

void minpush(int v)
{
    if(lazymin[v]){
        tmin[v*2] *= lazymin[v];
        tmin[v*2+1] *= lazymin[v];
        lazymin[v*2] *= lazymin[v];
        lazymin[v*2+1] *= lazymin[v];
        lazymin[v] = 1;
    }
}

void updatemin(int l, int r, long long add, int tl=1, int tr=mn, int v = 1)
{
    if(l > r) return;
    if(l <= tl && tr <= r){
        tmin[v] *= add;
        lazymin[v] *= add;
        return;
    }
    minpush(v);
    int tm = (tl + tr) >> 1;
    updatemin(l, min(r, tm), add, tl, tm, v*2);
    updatemin(max(l, tm+1), r, add, tm+1, tr, v*2 + 1);
    tmin[v] = min(tmin[v*2], tmin[v*2+1]);
}

long long ansmin(int l, int r, int tl=1, int tr = mn, int v = 1)
{
    if(l > tr || tl > r ||(l > r)){
      return 999999999ll;
    }
    if((l <= tl && tr <= r)){
        if(tmin[v] == 1) return 999999999ll;
        return tmin[v];
    }
    minpush(v);
    int tm = (tl+tr) >> 1;
    return min(ansmin(l, min(r, tm), tl, tm, v*2), ansmin(max(l, tm+1), r, tm+1, tr, v*2+1));
}


void push(int v)
{
    if(lazy[v]){
        t[v*2] *= lazy[v];
        t[v*2 + 1] *= lazy[v];
        lazy[v*2] *= lazy[v];
        lazy[v*2 + 1] *= lazy[v];
        lazy[v] = 1;
    }
}

void update(int l, int r, long long x, int tl=1, int tr=mn, int v=1)
{
    if(l > r) return;
    if(l <= tl && tr <= r){
        t[v] *= x;
        lazy[v] *= x;
        return;
    }
    push(v);
    int tm = (tl+tr) >> 1;
    update(l, min(r, tm), x, tl, tm, v*2);
    update(max(l, tm+1), r, x, tm+1, tr, v*2 + 1);
    t[v] = max(t[v*2], t[v*2+1]);
}

long long ans(int l, int r, int tl=1, int tr=mn, int v=1)
{
    if(l > tr || tl > r ||(l > r)){
      return -999999999;
    }
    if((l <= tl && tr <= r)){
        return t[v];
    }
    push(v);
    int tm = (tl+tr) >> 1;
    return max(ans(l, r, tl, tm, v*2), ans(l, r, tm+1, tr, v*2+1));
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    fill(tmin, tmin + mn*4,1);
    fill(lazy, lazy+ mn*4,1);
    fill(t, t+mn*4, 1);
    cin>>n>>q;
    int query, x, y, type;
    while(q > 0){
        cin>>query;
        if(query == 1){
            cin>>x>>y>>type;
            unsigned long long s = fpow(type);
            update(x, y, s);
            updatemin(x, y, s);
        }
        else{
            cin>>x>>y;
            if(ans(x, y) == ansmin(x,y)){
                cout<<"1\n";
            }
            else {
                cout<<"0\n";
            }
        }
        --q;
    }

    return 0;
}
