#include<iostream>
#include<vector>
#include<algorithm>
#include "periods.h"
using namespace std;
int periods[200000];
bool primes[200000];
int maxPeriod[200000];
std::vector<int> findPeriods(int n){
    for(int i=1;i<=n;i++){
        periods[i]=i;
    }
    for(int i=1;i<n;i++){
        int l=0,r=n/i;
        for(int j=1;j*j<=i;j++){
            if(i%j==0 && maxPeriod[j]>i){
                l=r=1;
            }
        }
        for(int j=1;j*j<=i;j++){
            if(i%j!=0 && maxPeriod[j]>i && maxPeriod[j]%i!=0){
                l=r=1;
            }
        }

        while(l<r){
            int m=(l+r+1)/2;
            //cout<<"bin: "<<i<<" "<<m<<" "<<hasPeriod(m*i,i)<<endl;
            if(periods[m*i]!=m*i || hasPeriod(m*i,i)){
                l=m;
            }else{
                r=m-1;
            }
        }
        //cout<<"check: "<<i<<" "<<l<<endl;
        maxPeriod[i]=i*l;
        for(int j=1;j<=l;j++){
            periods[i*j]=min(periods[i*j],i);
        }
    }
    vector<int>ans;
    for(int i=1;i<=n;i++){
        ans.push_back(periods[i]);
    }
    return ans;
}
