#include<bits/stdc++.h>
using namespace std;

using pii = pair<int, int>;
using drink = multiset<int>;

//Segment Tree

struct node
{
    //bool marked = false;
    bool isAllSame = true;
    drink dr = {};
    node() {}
};
int n, q;
vector<int> arr;
vector<node> t(2 * n);
/*
void combine(int v, int l, int r)
{
    //TODO
}

void build(int v, int l, int r)
{
    if(l == r)
    {
        t[l].ans = arr[l];
        return;
    }
    int mid = l + (r - l) / 2;
    int ri = v + 2 * (mid - l + 1);
    build(v + 1, l, mid);
    build(ri, mid + 1, r);
    combine(v, v + 1, ri);
}
*/
/*
const INV = 0;
int l, r, pos, val;
*/
void push(int v, int le, int ri)
{
    //TODO
    t[le].dr = t[ri].dr = t[v].dr;
    t[le].isAllSame = t[ri].isAllSame = true;
}

int l, r, x;


void pourDrink(drink& glass, int x)
{
    glass.insert(x);
}

//range update
void update(int v, int tl, int tr)
{
    if(tl > r || tr < l) return;

    int mid = tl + (tr - tl) / 2;
    int ri = v + 2 * (mid - tl + 1);
    if(l <= tl && tr <= r)
    {
        if(t[v].isAllSame)
        {
            t[v].dr.insert(x);
            return;
        }
    }
    /*
    if(t[v].marked)
    {
        push(v, v + 1, ri);
    }
    */
    update(v + 1, tl, mid);
    update(ri, mid + 1, tr);
    if(t[v + 1].isAllSame && t[ri].isAllSame && t[v + 1].dr == t[ri].dr)
    {
        t[v].isAllSame = true;
        t[v].dr = t[ri].dr;
    }
    else
    {
        t[v].isAllSame = false;
        t[v].dr = {};
    }
}

struct ansType
{
    bool isSubsAllSame;
    bool isOutside;
    drink dr;
};

drink err = {-1};
//ansType ERR = {true, true, err};

ansType printAns(ansType aaa)
{
    cout <<"same " <<aaa.isSubsAllSame <<" isOut " <<aaa.isOutside <<" dr";
    for(int p : aaa.dr) cout <<" " <<p; cout <<endl;
    return aaa;
}

ansType query(int v, int tl, int tr)
{
    //cout <<"q tl " <<tl <<" tr " <<tr <<endl;
    if(tl > r || tr < l)
    {
        //cout <<"alone 1 d -1\n";
        return /*printAns(*/{false, true, err};
    }
    if(l <= tl && tr <= r)
    {
        //cout <<"alone " <<t[v].isAllSame<<" d";
        //for(int p : t[v].dr) cout <<" " <<p; cout <<endl;
        if(t[v].isAllSame)
        return /*printAns(*/{t[v].isAllSame, false, t[v].dr};
    }

    int mid = tl + (tr - tl) / 2;
    int ri = v + 2 * (mid - tl + 1);
    /*
    if(t[v].isAllSame)
    {
        push(v, v + 1, ri);
    }
    */
    //int up = min(mid, qr), down = max(mid + 1, ql);
    ansType b1 = query(v + 1, tl, mid);
    ansType b2 = query(ri, mid + 1, tr);
    ansType aaa;
    if(!b1.isOutside && b2.isOutside)
    {
        aaa = { b1.isSubsAllSame, false, b1.dr };
    }
    else if(b1.isOutside && !b2.isOutside)
    {
        aaa = { b2.isSubsAllSame, false, b2.dr };
    }
    else if(b1.isSubsAllSame && b2.isSubsAllSame && b1.dr == b2.dr)
    {
        aaa = { true, false, b1.dr };
    }
    else aaa = { false, false, err};

    //cout <<"cont q tl " <<tl <<" tr " <<tr <<endl;
    return aaa;//printAns(aaa);//aaa;
}

void print(int v, int tl, int tr)
{
    cout <<"v " <<v <<" tl " <<tl <<" tr " <<tr <<" same " <<t[v].isAllSame;
    for(int p : t[v].dr)
    {
        cout <<" " <<p;
    }
    cout <<"\n";
    if(tl == tr) return;
    int mid = tl + (tr - tl) / 2;
    int ri = v + 2 * (mid - tl + 1);
    print(v + 1, tl, mid);
    print(ri, mid + 1, tr);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
/*
    multiset<int> s1, s2;
    s1.insert(0);
    s1.insert(0);
    s1.insert(1);
    s2.insert(0);
    s2.insert(0);
    s2.insert(1);

    cout <<(s1 == {0,0,1}) <<endl;
*/
    cin >>n >>q;
    t.assign(2 * n, node());
    int task;
    while(q--)
    {
        cin >>task >>l >>r;
        if(task == 1)
        {
            cin >>x;
            update(1, 1, n);
            //print(1, 1, n);
        }
        else
        {
            //print(1, 1, n);
            //cout <<(l == r ? 1 : query(1, 1, n, l, r)) <<'\n';
            cout <<(l == r ? 1 : query(1, 1, n).isSubsAllSame) <<'\n';
        }
    }
    //*/
}

/*
7 12
1 2 3 4
1 3 5 4
1 6 6 3
1 2 3 6
2 2 3
2 2 2
2 6 6
2 4 5
2 3 5
2 1 6
2 5 6
2 5 7

0
1
1
1
0
0
0
0


30 14
1 3 19 4
1 3 19 4
1 3 19 4
1 4 16 2
1 8 20 4
1 21 28 45
2 3 6
2 5 8
2 1 2
2 1 4
2 1 3
2 6 9
2 18 19
2 19 20

0
0
1
0
0
1
1
0
*/
