#include <iostream>
#include <set>

using namespace std;

const int maxn = 2*10e5 + 10;
multiset <int> L[maxn];
multiset <int> R[maxn];
set <int> breakers;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q;
    cin >> n >> q;

    for(int qn = 1; qn <= q; qn++){ ///qn = question number
        int qt;  ///qt = question type
        cin >> qt;
        if(qt == 1){
            int l, r, x;
            cin >> l >> r >> x;

            if(l > 1){
                auto itR = R[l-1].lower_bound(x);
                if(*itR == x){
                    R[l-1].erase(x);
                    if(L[l].empty() && R[l-1].empty()) breakers.erase(l-1);
                }
                else{
                    L[l].insert(x);
                    breakers.insert(l-1);
                }

            }

            if(r < n){
                auto itL = L[r+1].lower_bound(x);
                if(*itL == x){
                    L[r+1].erase(x);
                    if(L[r+1].empty() && R[r].empty()) breakers.erase(r);
                }
                else{
                    R[r].insert(x);
                    breakers.insert(r);
                }
            }
        }
        else{  ///qt == 2
            int l, r;
            cin >> l >> r;

            auto it = breakers.lower_bound(l);
            if(*it >=r || breakers.empty()) cout << 1 << endl;
            else cout << 0 << endl;
        }
    }

    return 0;
}
