
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;

void read() {
    cin >> n >> q;
}

vector<map<int, int>> cups;

void add(int l, int r, int type) {
    for (int i = l; i <= r; i++) {
        cups[i][type]++;
    }
}

bool query(int l, int r) {
    for (int i = l + 1; i <= r; i++) {
        if (cups[i] != cups[l]) {
            return false;
        }
    }

    return true;
}

void solve() {
    cups.resize(n);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        l--;
        r--;

        if (type == 1) {
            int t;
            cin >> t;

            add(l, r, t);
        } else {
            cout << query(l, r) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
