#include <bits/stdc++.h>
#include "periods.h"

#pragma GCC optimize "-O3"

/*
#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
*/

using namespace std;

vector<int> findPeriods(int n) {
    vector<int> answer(n);

    for (int i = 0; i < n; i++) {
        vector<int> divs;

        for (int j = 1; j * j <= (i + 1); j++) {
            if ((i + 1) % j == 0) {
                divs.emplace_back(j);

                if ((i + 1) / j != j) {
                    divs.emplace_back((i + 1) / j);
                }
            }
        }

        sort(divs.begin(), divs.end());

        for (int j : divs) {
            if (hasPeriod(i + 1, j)) {
                answer[i] = j;
                break;
            }
        }
    }

    return answer;
}
