#include <bits/stdc++.h>
#include "periods.h"

#pragma GCC optimize "-O3"

/*
#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
*/

using namespace std;

vector<int> findPeriods(int n) {
    vector<int> answer(n);
    vector<bool> skip(n, false);

    for (int i = 0; i < n; i++) {
        answer[i] = i + 1;
    }

    for (int i = 0; i < n; i++) {
        if (skip[i]) {
            continue;
        }

        int low = 1, high = (n - i - 1) / answer[i];
        int bestOffset = -1;

        while (low <= high) {
            int mid = low + ((high - low) >> 1);
            int pos = i + mid * answer[i];

            if (hasPeriod(pos + 1, answer[i])) {
                bestOffset = mid;
                low = mid + 1;
            } else {
                high = mid - 1;
            }
        }

        for (int j = 1; j <= bestOffset; j++) {
            int pos = i + j * answer[i];
            skip[pos] = true;
            answer[pos] = answer[i];
        }
    }

    return answer;
}
