# include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize ("03")
//#pragma GCC target ("sse4")
const int maxn = 6e5+5;
struct Segment_tree
{
    map <int, int> segm[maxn];
    int p[maxn],n[maxn];
    void update(int v, int from, int to, int x, int k,int d)
    {
        if(from==to&&from==x)
        {
            if(segm[v].count(k))
            {
                if(segm[v][k]>0)p[v]--;
                else if(segm[v][k]<0)
                    n[v]--;
                segm[v][k]+=d;
                 if(segm[v][k]>0)p[v]++;
                else if(segm[v][k]<0)
                    n[v]++;

            }
            else
            {
                segm[v][k] = d;
                if(d>0)p[v]++;
                else
                    n[v]++;
            }
            return ;
        }
        int mid = (from+to)>>1;
        if(x<=mid)update(2*v,from,mid,x,k,d);
        else
            update(2*v+1,mid+1,to,x,k,d);

        p[v] = p[2*v]+p[2*v+1];
        n[v] = n[2*v]+n[2*v+1];
    }
    pair <int, int> query(int v, int from, int to, int x, int y)
    {
         if(x<=from&&to<=y){
            return {p[v],n[v]};
         }
        int mid = (from+to)>>1;
        pair <int,int> ans,ans2;
        ans.first = 0;
        ans.second = 0;
        if(x<=mid)ans = query(2*v,from,mid,x,y);

        if(y>mid){ans2 = query(2*v+1,mid+1,to,x,y);ans.first+=ans2.first;ans.second+=ans2.second;}
        return ans;
    }
};
Segment_tree seg;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,q;
    cin>>n>>q;
    int i,j;
    int t,x,y,z;
    for(i=1;i<=q;i++)
    {
        cin>>t>>x>>y;
        if(t==1)
        {
            cin>>z;
            seg.update(1,1,n,x,z,1);
            if(y<n)
            seg.update(1,1,n,y+1,z,-1);
        }
        else
        {
            int k = seg.query(1,1,n,x+1,y).first+seg.query(1,1,n,x+1,y).second;
            if(k>0)cout<<0<<endl;
            else
                cout<<1<<endl;
        }
    }
    return 0;
}
