#include "periods.h"

std::vector<int> findPeriods(int n) {
    std::vector<int> res(n);
    res[0] = 1;

    for (auto i = 1; i < n; ++i) {
        for (auto j = 1; ; ++j) {
            if (hasPeriod(i + 1, j)) {
                res[i] = j;
                break;
            }
        }
    }

    return res;
}
