#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")

using namespace std;

const long long MOD = 1e9+7;
const long long MOD2 = 1e7+9;
const int p = 31;
const int p2 = 127;
const int X = 1e5 + 10;
const int N = 1e5 + 10;

void operator+=(pair<long long, long long>& l, const pair<long long, long long>& r) {
    l.f = (l.f + r.f) % MOD;
    l.s = (l.s + r.s) % MOD2;
}

int n, q;
long long ppow[X], ppow2[X];
pair<long long, long long> st[4*N];
pair<long long, long long> lp[4*N];

void updateLazy(int curr, bool leaf) {
    pair<long long, long long> temp = lp[curr];
    lp[curr] = {0, 0};

    if (st[curr].f != -1) {
        st[curr] += temp;
    }
    if (leaf) {
        return;
    }

    lp[curr*2] += temp;
    lp[curr*2+1] += temp;
}

pair<long long, long long> func(const pair<long long, long long>& l, const pair<long long, long long>& r) {
    if (l == r) {
        return l;
    }
    return {-1, -1};
}

void update(int curr, int l, int r, int ll, int rr, const pair<long long, long long>& val) {
    updateLazy(curr, l==r);
    if (l > rr || r < ll) {
        return;
    }
    if (l >= ll && r <= rr) {
        lp[curr] = val;
        updateLazy(curr, l==r);
        return;
    }

    int mid = (l+r)/2;
    update(curr*2, l, mid, ll, rr, val);
    update(curr*2+1, mid+1, r, ll, rr, val);
    st[curr] = func(st[curr*2], st[curr*2+1]);
}

pair<long long, long long> query(int curr, int l, int r, int ll, int rr) {
    updateLazy(curr, l==r);
    if (l > rr || r < ll) {
        return {-1, -1};
    }
    if (l >= ll && r <= rr) {
        return st[curr];
    }

    int mid = (l+r)/2;
    pair<long long, long long> p1 = query(curr*2, l, mid, ll, rr);
    pair<long long, long long> p2 = query(curr*2+1, mid+1, r, ll, rr);
    if (mid+1 > rr) {
        return p1;
    } else if (mid < ll) {
        return p2;
    }
    return func(p1, p2);
}

void input() {
    cin>>n>>q;
}

void calcPow() {
    ppow[0] = 1;
    ppow2[0] = 1;
    for (int i=1; i<X; i++) {
        ppow[i] = ppow[i-1]*p % MOD;
        ppow2[i] = ppow2[i-1]*p2 % MOD2;
    }
}

void solve() {
    calcPow();

    int type, l, r, val;
    for (int i=0; i<q; i++) {
        cin>>type>>l>>r;
        if (type == 1) {
            cin>>val;
            update(1, 1, n, l, r, {ppow[val], ppow2[val]});
        } else {
            cout<<(query(1, 1, n, l, r).f != -1)<<'\n';
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    return 0;
}

/*
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 2
*/
