#include "periods.h"

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    ans[0] = 1;
    for(int i = 1; i < n; ++i){
        int len = i + 1;
        int len2 = len;

        for(int j = 1; j <= len; ++j)
            if(hasPeriod(len, j)){
                ans[i] = j;
                break;
            }
    }
    return ans;
}

