#include "periods.h"

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    ans[0] = 1;
    for(int i = 1; i < n; ++i){
        int len = i + 1;
        int len2 = len;

        vector<int> d;
        int j;
        for(j = 1; j * j <= len; ++j)
            if(len % j == 0)
                d.push_back(j);
        --j;
        if(j * j == len) --j;
        for(;j >= 1; --j)
            if(len % j == 0)
                d.push_back(len / j);

        for(int x: d)
        if(hasPeriod(len, x)){
            ans[i] = x;
            break;
        }
    }
    return ans;
}

