#include <bits/stdc++.h>

using namespace std;

#define MAX 210000

#define MOD 10000000000000000

struct op
{
	unsigned long long a, b;
};

long long kl;

op operator+(op l, op r)
{
	l.a += r.a;
	l.b += r.b;
	l.a += (l.b / MOD);
	l.b %= MOD;
	return l;
}

op operator*(op l, long long r)
{
	l.a *= r;
	l.b *= r;
	l.a += (l.b / MOD);
	l.b %= MOD;
	return l;
}


long long n, q, a, b, x;

op lazy[4 * MAX], ty;

pair<op, op> tr[4 * MAX], tmp;

bool erat[7 * MAX];

vector<long long> pr;

void update(int v, int l, int r, int ql, int qr, op val)
{
	op ui, iu;
	if(lazy[v].b != 0)
	{
		tr[v].first = tr[v].first + lazy[v];
		tr[v].second = tr[v].second + lazy[v];
		if(l != r)
		{
			lazy[v * 2] = lazy[v * 2] + lazy[v];
			lazy[v * 2 + 1] =  lazy[v * 2 + 1] + lazy[v];
		}
		lazy[v] = {0, 0};
	}
	if(r < l)return ;
	if(ql > r || qr < l)return;
		
	if(l == r)
	{
		tr[v].first = tr[v].first + val;
		tr[v].second = tr[v].second + val;
		return ;
	}
	if(ql <= l && r <= qr)
	{
		tr[v].first = tr[v].first + val;
		tr[v].second = tr[v].second + val;
		lazy[v * 2] = lazy[v * 2] + val;
		lazy[v * 2 + 1] = lazy[v * 2 + 1] + val;
		return ;
	}
	int mid = (l + r) / 2;
	update(v * 2, l, mid, ql, qr, val);
	update(v * 2 + 1, mid + 1, r, ql, qr, val);
	pair<op, op > t1 = tr[v * 2];
	pair<op, op >t2 = tr[v * 2 + 1];
	ui = t1.first;
	if(t1.first.a > t2.first.a)ui = t2.first;
	else if(t1.first.a == t2.first.a && t1.first.b > t2.first.b)ui = t2.first;
	iu = t2.second;
	if(t1.second.a > t2.second.a)iu = t1.second;
	else if(t1.second.a == t2.second.a && t1.second.b > t2.second.b)iu = t1.second;
	
	tr[v].first = ui;
	tr[v].second = iu;
}

pair<op, op> query(int v, int l, int r, int ql, int qr)
{
	op iu, ui, ui2, iu2;
	if(lazy[v].b != 0)
	{
		tr[v].first = tr[v].first + lazy[v];
		tr[v].second = tr[v].second + lazy[v];
		if(l != r)
		{
			lazy[v * 2] = lazy[v * 2] + lazy[v];
			lazy[v * 2 + 1] =  lazy[v * 2 + 1] + lazy[v];
		}
		lazy[v] = {0, 0};
	}
	ui2.a = 26654140;
	ui2.b = MOD - 1;
	iu2.a = 0;
	iu2.b = 0;
	if(ql > r || qr < l)return {ui2, iu2};
	if(ql <= l && r <= qr)
	{
		return tr[v];
	}
	int mid = (l + r) / 2;
	pair<op, op > t1 = query(v * 2, l, mid, ql, qr);
	pair<op, op >t2 = query(v * 2 + 1, mid + 1, r, ql, qr);
	
	ui = t1.first;
	if(t1.first.a > t2.first.a)ui = t2.first;
	else if(t1.first.a == t2.first.a && t1.first.b > t2.first.b)ui = t2.first;
	iu = t2.second;
	if(t1.second.a > t2.second.a)iu = t1.second;
	else if(t1.second.a == t2.second.a && t1.second.b > t2.second.b)iu = t1.second;
	return {ui, iu};
}
 
int main()
{
	
	erat[0] = erat[1] = 1;
	for(long long i = 2; i < 7 * MAX; i++)
	{
		if(erat[i] == 0)
		{
			pr.push_back(i);
			for(long long j = i * i; j < 7 * MAX; j += i)erat[j] = 1;
		}
	}
	scanf("%lld%lld", &n, &q);
	for(int i = 0; i < q; i++)
	{
		scanf("%lld", &a);
		if(a == 1)
		{
			scanf("%lld%lld%lld", &a, &b, &x);
			ty = {0, 2000007};
			ty = ty * pr[x + 10000];
			ty = ty * x;
			//cout << ty.b << endl;
			update(1, 1, n, a, b, ty);
		}
		else
		{
			scanf("%lld%lld", &a, &b);
			tmp = query(1, 1, n, a, b);
			if(tmp.first.a != tmp.second.a || tmp.first.b != tmp.second.b)printf("0\n");
			else printf("1\n");
			//cout << tmp.first.a << " " << tmp.second.a << endl;
		}
	}//cout  << tr[0].first.b << endl;

	return 0;
}

/*

4 7
2 1 3
1 1 3 51000
1 3 4 69842
2 1 3
2 1 2
1 2 2 51000
2 1 2


4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2


*/