#include "periods.h"
#include <bits/stdc++.h>

using namespace std;

#define MAX 110000

bool erat[MAX];

int pw(int a, int x)
{
	if(x == 0)return 1;
	if(x == 1)return 0;
	int res = pw(a, x / 2);
	res *= res;
	if(x % 2 == 0)return res;
	return res * a;
}

std::vector<int> findPeriods(int n)
{
	int mn, l, r, mid, br;
	erat[0] = erat[1] = 1;
	for(long long i = 2; i < MAX; i++)
	{
		if(erat[i] == 0)
		{
			for(long long j = i * i; j < MAX; j += i)erat[j] = 1;
		}
	}
	bool fl;
	vector<int> p;
	p.resize(n);
	for(int i = n; i > 0; i--)
	{
		fl = false;
		if(p[i - 1] != 0)continue;
		for(int j = 1; j < MAX; j++)
		{
			if(erat[j] == 1)continue;
			if(i % j != 0)continue;
			mn = 1;
			br = 0;
			while(mn <= i)
			{
				mn *= j;
				br++;
			}
			br--;
			mn /= j;
			int l = 0, r = br;
			while(l <= r)
			{
				mid = (l + r) / 2;
				if(mid > p[i - 1])
				{
					r = mid - 1;
					continue;
				}
				mn = pw(j, mid);
				if(hasPeriod(i, mn) == 1)
				{
					for(int k = i; k >= 1; k -= mn)p[k - 1] = mn;
					r = mid - 1;
				}
				else l = mid + 1;
			}
		}
		if(fl == false || erat[p[i - 1]] == 0)
		{
			if(hasPeriod(i, 1) == 1)
			{
				for(int j = i; j >= 1; j--)p[j - 1] = 1;
			}
			else p[i - 1] = i;
		}
		if(p[i - 1] == 0)p[i - 1] = i;
		
	}
	return p;
}




