#include "periods.h"
// #include "Lgrader.cpp"
#include <algorithm>
using namespace std;

std::vector<int> findPeriods(int n)
{
    vector<int> periods;

    periods.push_back(1);
    for (int i = 2; i <= n; ++ i)
    {
        vector<int> div;
        for (int j = 1; j * j <= i; ++ j)
        {
            if (j * j == i)
            {
                div.push_back(j);
            }
            else if (i % j == 0)
            {
                div.push_back(j);
                div.push_back(i / j);
            }
        }
        sort(div.begin(), div.end());

        /*cout << "divisors of " << i << ": ";
        for (int j = 0; j < div.size(); ++ j) cout << div[j] << ' ';
        cout << endl;*/

        int period = i;
        for (int j = 0; j < div.size() - 1; ++ j)
        {
            int pos = i - div[j] - 1;
            if (periods[pos] <= div[j])
            {
                if (hasPeriod(i, div[j]))
                {
                    period = div[j];
                    break;
                }
            }
        }

        periods.push_back(period);
    }

    return periods;
}

/*
18
1 2 3 4 1 2 1 2 3 4 1 2 1 2 3 4 1 2
1 2 3 4 5 6 7 8 9 10 11 6 13 14 15 16 17 6
*/
