#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const int MAXN = 200002;
pair<int,bool> arr[4*MAXN];

pair<int,bool> mergePairs(pair<int,bool> a, pair<int,bool> b) {
    if(a.first == -1) {
        return b;
    }
    if(b.first == -1) {
        return a;
    }
    if(a.second and b.second and a.first == b.first) {
        return a;
    }
    else {
        return {0, false};
    }
}

void push(int v) {
    arr[2*v] = arr[v];
    arr[2*v+1] = arr[v];
}

void build(int v, int tl, int tr) {
    if(tl == tr) {
        arr[v] = {0, true};
        return;
    }
    int mid = (tl+tr)/2;
    build(2*v, tl, mid);
    build(2*v+1, mid+1, tr);
    arr[v] = mergePairs(arr[2*v], arr[2*v+1]);
}

void change(int v, int tl, int tr, int l, int r, int val) {
    if(tl > r or tr < l) {
        return;
    }
    if(l <= tl and tr <= r) {
        arr[v] = {val, true};
        return;
    }
    int mid = (tl+tr) / 2;
    change(2*v, tl, mid, l, r, val);
    change(2*v+1, mid+1, tr, l, r, val);
    arr[v] = mergePairs(arr[2*v], arr[2*v+1]);
}

pair<int,bool> query(int v, int tl, int tr, int l, int r) {
    //cout<<"inside"<<tl<<":"<<tr<<endl;
    if(tl > r or tr < l) {
        return {-1, true};
    }
    if(l <= tl and tr <= r) {
        //cout<<"getting value from"<<tl<<":"<<tr<<"="<<arr[v].first<<"_"<<arr[v].second<<endl;
        return arr[v];
    }
    if(arr[v].first > 0) {
        push(v);
    }
    int mid = (tl+tr)/2;
    return mergePairs(query(2*v, tl, mid, l, r), query(2*v+1, mid+1, tr, l, r));
}
int main() {
    int n,q;
    cin>>n>>q;
    build(1, 1, n);
    int u,l,r;
    while(q--) {
        cin>>u>>l>>r;
        if(u == 1) {
            cin>>u;
            change(1, 1, n, l, r, u);
        }
        else {
            cout<<query(1, 1, n, l, r).second<<endl;
        }
    }
}

