#include<iostream>
#include<vector>
#include<cstdio>
#include"periods.h"

bool hasPeriod(int len, int period);

std::vector<int> findPeriods(int n)
{
    std::vector<int> ret = {1};
    int curMax = 1;

    for (int i=2; i<=n; i++)
    {
        bool res = hasPeriod(i, curMax);

        //std::cout<<i<<" "<<curMax<<" "<<res<<std::endl;

        if (res) ret.push_back(curMax);
        else
        {
            curMax++;
            if (curMax == i)
            {
                ret.push_back(curMax);
            }
            else i--;
        }
    }

    return ret;
}
