#include<iostream>
#include <vector>
#include"periods.h"

int biggestDiv[100001];
std::vector<int> primes;

void sito(int n)
{
    biggestDiv[1] = 1;
    for (int i=2; i<=n; i++)
    {
        if (biggestDiv[i] == 0)
        {
            primes.push_back(i);
            biggestDiv[i] = i;
            int j=i+i;
            while (j <= n)
            {
                biggestDiv[j] = std::max(biggestDiv[j], j/i);
                j += i;
            }
        }
    }
}

bool hasPeriod(int len, int period);

std::vector<int> findPeriods(int n)
{
    sito(n);

    std::vector<int> ret;
    int ans[n+1];

    for (int i=1; i<=n; i++) ans[i] = -1;

    int final1=1;

    ans[1] = 1;

    for (int i=0; i<primes.size(); i++)
    {
        bool res = hasPeriod(primes[i], 1);
        if (res)
        {
            final1 = primes[i];
            ans[primes[i]] = 1;
            if (i != 0)
            {
                for (int j=primes[i]-1; j>primes[i-1]; j--) ans[j] = 1;
            }
        }
        else
        {
            for (; i<primes.size(); i++) ans[primes[i]] = primes[i];
            break;
        }
    }

    for (int i=final1+1; i<=n; i++)
    {
        if (ans[i] == -1)
        {
            for (int x = i/biggestDiv[i]; x<=i; x += i/biggestDiv[i])
            {
                if (i%x != 0) continue;
                if (x == i)
                {
                    ans[i] = i;
                    break;
                }
                if (hasPeriod(i, x))
                {
                    ans[i] = x;
                    break;
                }
            }
        }
    }



    for (int i=1; i<=n; i++) ret.push_back(ans[i]);
    return ret;
}
