#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e5+5;
int base=1e5+3;///make 1e5+3 if needed
int h[MAXN],p[MAXN],n;
void init()
{
    p[0]=1;
    for(int i=1; i<=MAXN-3; i++)p[i]=base*p[i-1];
}
void add(int l,int r,int x)
{
    for(int i=l; i<=r; i++)h[i]+=p[x];
}
void solve(int l,int r)
{
    long long curr=h[l];
    for(int i=l+1; i<=r; i++)
    {
        if(curr!=h[i])
        {
            cout<<0<< "\n";
            return;
        }
    }
    cout<<1<< "\n";
}

int tree[4*MAXN];

int fnd(int k,int l,int r,int x)
{
    tree[2*k]=tree[2*k+1]=tree[k];
    if(x>=l&&x<=r||l==r)return tree[k];
    int m=(l+r)/2;
    if(m>=x)return fnd(k*2,l,m,x);
    return fnd(k*2+1,m+1,r,x);
}
void update(int k,int l,int r,int ql,int qr,int v)
{
    if(r<ql||l>qr)return;
    if(l>=ql&&r<=qr)
    {
        tree[k]=v;
        return;
    }
    tree[2*k]=tree[2*k+1]=tree[k];
    int m=(l+r)/2;
    update(2*k,l,m,ql,qr,v);
    update(2*k+1,m+1,r,ql,qr,v);
}
void add2(int l,int r,int x)
{
    update(1,1,n,l,r,x);
}
void solve2(int l,int r)
{
    if(fnd(1,1,n,l)==fnd(1,1,n,r))cout<<1<<'\n';
    else cout<<0<<'\n';
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q,t,ql,qr,qx;
    init();
    cin>>n>>q;
    while(q--)
    {
        cin>>t;
        if(t==1)
        {
            cin>>ql>>qr>>qx;
            //add(ql,qr,qx);
            add2(ql,qr,qx);
        }
        else
        {
            cin>>ql>>qr;
            //solve(ql,qr);
            solve2(ql,qr);
        }
    }
    return 0;
}
/**
5 5
2 1 3
1 1 2 5
1 3 4 6
2 1 4
2 4 5
*/
