#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e5+5;
int base=1e5+3;///make 1e5+3 if needed
int h[MAXN],p[MAXN],n;

int tree_mx[4*MAXN],tree_mn[MAXN*4],lazy[4*MAXN];
void push_lazy(int k)
{
    lazy[2*k]+=lazy[k];
    lazy[2*k+1]+=lazy[k];

    tree_mn[k]+=lazy[k];
    tree_mx[k]+=lazy[k];
    lazy[k]=0;
}
int fnd_min(int k,int l,int r,int ql,int qr)
{
    if(l>qr||r<ql)return MAXN;
    if(l>=ql&&qr>=r)return tree_mn[k]+lazy[k];
    push_lazy(k);
    int m=(l+r)/2;
    return min(fnd_min(k*2+1,m+1,r,ql,qr),fnd_min(k*2,l,m,ql,qr));
}
int fnd_max(int k,int l,int r,int ql,int qr)
{
    if(l>qr||r<ql)return 0;
    if(l>=ql&&qr>=r)return tree_mx[k]+lazy[k];
    push_lazy(k);
    int m=(l+r)/2;
    return max(fnd_max(k*2+1,m+1,r,ql,qr),fnd_max(k*2,l,m,ql,qr));
}
void update(int k,int l,int r,int ql,int qr,int v)
{
    if(r<ql||l>qr)return;
    if(l==r)
    {
        tree_mn[k]+=v;
        tree_mx[k]+=v;
        return;
    }
    if(l>=ql&&r<=qr)
    {
        lazy[k]+=v;
        return;
    }
    push_lazy(k);

    int m=(l+r)/2;
    update(2*k,l,m,ql,qr,v);
    update(2*k+1,m+1,r,ql,qr,v);
    tree_mn[k]=min(tree_mn[2*k]+lazy[2*k],tree_mn[2*k+1]+lazy[2*k+1]);
    tree_mx[k]=max(tree_mx[2*k]+lazy[2*k],tree_mx[2*k+1]+lazy[2*k+1]);
}
void add2(int l,int r,int x)
{
    update(1,1,n,l,r,x);
    //cout<<fnd_max(1,1,n,l,r)<<" "<<fnd_min(1,1,n,l,r)<<'\n';
}
void solve2(int l,int r)
{
    //cout<<fnd_max(1,1,n,l,r)<<" "<<fnd_min(1,1,n,l,r)<<'\n';
    if(fnd_max(1,1,n,l,r)==fnd_min(1,1,n,l,r))cout<<1<<'\n';
    else cout<<0<<'\n';
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q,t,ql,qr,qx;
    //init();
    cin>>n>>q;
    while(q--)
    {
        cin>>t;
        if(t==1)
        {
            cin>>ql>>qr>>qx;
            //add(ql,qr,qx);
            add2(ql,qr,qx);
        }
        else
        {
            cin>>ql>>qr;
            //solve(ql,qr);
            solve2(ql,qr);
        }
    }
    return 0;
}

/**
5 7
2 1 3
1 1 2 5
1 3 4 6
2 1 4
2 4 5
1 5 5 1
2 1 5
*/
