#include<iostream>
#include<queue>

using namespace std;

//int matrix[20005][10005];
//int sizes[20005];

priority_queue<int> q[105];

void action(int s, int e, int x)
{
    for(int i = s - 1; i <= e - 1; i++)
    {
        //matrix[i][x]++;
        //sizes[i]++;

        q[i].push(x);
    }
}

bool check(int s, int e)
{
    s--;
    e--;

    for(int i = s + 1;i <= e;i++)
    {
        if(q[i].size() != q[s].size())
        {
            return false;
        }
    }

    while(!q[s].empty())
    {
        for(int i = s + 1;i <= e;i++)
        {
            if(q[i].top() != q[s].top())
            {
                return false;
            }
            q[i].pop();
        }
        q[s].pop();
    }

    return true;
}

int main()
{
    int n,m;

    cin>>n>>m;

    queue<bool> res;

    for(int i = 0;i < m;i++)
    {
        int type;

        cin>>type;

        if(type == 1)
        {
            int s;
            int e;
            int x;

            cin>>x>>s>>e;
            action(s, e, x);
        }

        if(type == 2)
        {
            int s;
            int e;

            cin>>s>>e;
            res.push(check(s, e));
        }
    }

    while(!res.empty())
    {
        cout<<res.front()<<endl;
        res.pop();
    }
}
