#include "periods.h"
///using namespace std;
const int MAXN=1e5+10;
std::vector <int> pr[MAXN];
bool er[MAXN];
void eratosten(int n) {
    for (int i=4;i<=n;i+=2) {
        pr[i].push_back(2);
        er[i]=true;
    }
    for (long long i=3;i<=n;i++) {
        if (!er[i]) {
            for (long long j=i*2;j<=n;j+=2*i) {
                er[j]=true;
                pr[j].push_back(i);
            }
        }
    }
}
std::vector<int> findPeriods(int n) {
    eratosten(n);
    std::vector <int> ans;
    ans.push_back(1);
    int br=1;
    bool fl;
    for (int i=2;i<=n;i++) {
        if (ans[br-1]==1 && hasPeriod(i,1)) {
            ans.push_back(1);
            br++;
            continue;
        }
        fl=false;
        for (int j=0;j<pr[i].size();j++) {
            if (ans[br-pr[i][j]]==pr[i][j] && hasPeriod(i,pr[i][j])) {
                ans.push_back(pr[i][j]);
                fl=true;
                break;
            }
        }
        if (!fl) ans.push_back(i);
        br++;
    }
    return ans;
}
