#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define hash sdfdsf
#define merge dsfdsfsd
vector<ll>primes;
const ll target=2e5;
const ll MAXN=2e5+6;
const ll MAXM=1e6+6;
const ll mod1=100000000005000097;
const ll mod2=100000000005000131;
const ll mod3=100000000005000187;
const ll mod4=100000000005000241;
ll p[MAXM];
ll b1[MAXN];
ll b2[MAXN];
ll b3[MAXN];
ll b4[MAXN];
struct hash
{
    ll h1,h2,h3,h4;
    hash()
    {
        h1=0;h2=0;h3=0;h4=0;
    }
    void pour(ll d)
    {
        h1+=b1[d];
        h2+=b2[d];
        h3+=b3[d];
        h4+=b4[d];
        h1%=mod1;
        h2%=mod2;
        h3%=mod3;
        h4%=mod4;
    }
};
bool eq(hash a,hash b)
{
    return a.h1==b.h1&&a.h2==b.h2&&a.h3==b.h3&&a.h4==b.h4;
}
void sieve()
{
    //cout<<"sieve\n";
    primes.push_back(2);
    p[1]=1;
    //cout<<"?1\n";
    for(ll i=4;i<MAXM;i+=2)p[i]=1;
    //cout<<"?2\n";
    for(ll i=3;i<MAXM;i++)
    {
        //cout<<i<<endl;
        if(p[i]==0)
        {
            primes.push_back(i);
            if(primes.size()==target)
            {
                //cout<<"ok\n";
                break;
            }
            if(i<sqrt(MAXM))
            for(ll j=i*i;j<MAXM;j+=2*i)
            {
                p[j]=1;
            }
        }
    }
    //cout<<primes.size()<<endl;
}
ll n,q;
hash add(hash a,hash b)
{
    a.h1=(a.h1+b.h1)%mod1;
    a.h2=(a.h2+b.h2)%mod2;
    a.h3=(a.h3+b.h3)%mod3;
    a.h4=(a.h4+b.h4)%mod4;
    return a;
}
struct segment_tree
{
    struct node
    {
        hash hesh;
        bool all_equal;
        hash lazy;
    };
    node tree[4*MAXN];
    node merge(node n1,node n2)
    {
       // cout<<"%%%\n";
        node ret;
        if(n1.all_equal&&n2.all_equal&&eq(n1.hesh,n2.hesh))
        {
            ret.all_equal=1;ret.hesh=n1.hesh;
        }
        else
        {
            ret.all_equal=0;
        }
        return ret;
    }
    void push_lazy(ll l,ll r,ll idx)
    {
        tree[idx].hesh=add(tree[idx].hesh,tree[idx].lazy);
        if(l!=r)
        {
            tree[idx*2].lazy=add(tree[idx*2].lazy,tree[idx].lazy);
            tree[idx*2+1].lazy=add(tree[idx*2+1].lazy,tree[idx].lazy);
        }
        tree[idx].lazy=hash();
    }
    void build(ll l,ll r,ll idx)
    {
        if(l==r)
        {
            tree[idx].all_equal=1;
            return;
        }
        ll mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        push_lazy(l,mid,idx*2);
        push_lazy(mid+1,r,idx*2+1);
        tree[idx]=merge(tree[idx*2],tree[idx*2+1]);
    }
    void update(ll l,ll r,ll ql,ll qr,ll idx,ll val)
    {
        push_lazy(l,r,idx);
        if(l>qr||r<ql)return;
        if(l>=ql&&r<=qr)
        {
            tree[idx].lazy.pour(val);
            push_lazy(l,r,idx);
            return;
        }
        ll mid=(l+r)/2;
        update(l,mid,ql,qr,idx*2,val);
        update(mid+1,r,ql,qr,idx*2+1,val);
        push_lazy(l,mid,idx*2);
        push_lazy(mid+1,r,idx*2+1);
        tree[idx]=merge(tree[idx*2],tree[idx*2+1]);
    }
    node query(ll l,ll r,ll ql,ll qr,ll idx)
    {
        push_lazy(l,r,idx);
        if(l>=ql&&r<=qr)
        {
            return tree[idx];
        }
        ll mid=(l+r)/2;
        if(qr<=mid)
        {
            push_lazy(mid+1,r,idx*2+1);
            return query(l,mid,ql,qr,idx*2);
        }
        if(ql>mid)
        {
            push_lazy(l,mid,idx*2);
            return query(mid+1,r,ql,qr,idx*2+1);
        }
        node n1=query(l,mid,ql,qr,idx*2);
        node n2=query(mid+1,r,ql,qr,idx*2+1);
        return merge(n1,n2);
    }
    bool query(ll l,ll r)
    {
        node gg=query(1,n,l,r,1);
        return gg.all_equal;
    }
    void print(ll l,ll r,ll idx)
    {

        cout<<l<<" "<<r<<" "<<idx<<":\n";
        cout<<tree[idx].hesh.h1<<" "<<tree[idx].hesh.h2<<endl;
        cout<<tree[idx].lazy.h1<<" "<<tree[idx].lazy.h2<<endl;
        cout<<tree[idx].all_equal<<endl;
        if(l==r)return;
        print(l,(l+r)/2,idx*2);
        print((l+r)/2+1,r,idx*2+1);
    }
}t;
ll cnt[MAXN];
struct query
{
    ll type;
    ll l,r,x;
};
vector<query>v;
ll find_next_prime(ll i)
{
    for(ll j=i+1;;j++)
    {
        if(p[j]==0)
        {
            return j;
        }
    }
}
int main()
{
    //cout<<"?????\n";
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //cout<<"?\n";
    srand(231232);
    //cout<<"GGG\n";
    sieve();
    //cout<<"%%%\n";
    //cout<<"?\n";
    //cout<<"??\n";
    cin>>n>>q;
    //cout<<"^\n";
    t.build(1,n,1);
    //cout<<"&\n";
    for(ll i=0;i<q;i++)
    {
        ll type;
        cin>>type;
        if(type==1)
        {
            ll l,r,x;
            cin>>l>>r>>x;
            cnt[x]++;
            v.push_back({type,l,r,x});
        }
        else
        {
            ll l,r;
            cin>>l>>r;
            v.push_back({type,l,r,-1});
        }
        //t.print(1,n,1);
    }
    ll t1=1;
    ll t2=1;
    ll t3=1;
    ll t4=1;
    for(ll i=1;i<MAXN;i++)
    {
        if(cnt[i]==0)continue;
        b1[i]=t1;
        b2[i]=t2;
        b3[i]=t3;
        b4[i]=t4;
        ll f=find_next_prime(cnt[i]);
        t1*=f;t1%=mod1;
        f=find_next_prime(f);
        t2*=f;t2%=mod2;
        f=find_next_prime(f);
        t3*=f;t3%=mod3;
        f=find_next_prime(f);
        t4*=f;t4%=mod4;
    }
    for(ll i=0;i<q;i++)
    {
        if(v[i].type==1)
        {
            t.update(1,n,v[i].l,v[i].r,1,v[i].x);
        }
        else
        {
            cout<<t.query(v[i].l,v[i].r)<<endl;
        }
    }
return 0;
}
/*
10000000069
10000000097
10000000103
10000000121
*/
