#include<bits/stdc++.h>
#include "periods.h"
using namespace std;

const int MAXN = 100000;
int smallestPeriod[MAXN+1];

int FindSmallestPeriod(int minValue, int maxValue, int len)
{
    // Biggest period that the current prefix has not.
    int left = minValue;
    // Smallest period that the current prefix has.
    int right = maxValue, mid;
    while(left < right)
    {
        mid = (left+right)/2;
        if(hasPeriod(len, mid)) right = mid;
        else left = mid;
    }
    return right;
}

vector<int> findPeriods(int n)
{
    vector<int> returnValue;
    smallestPeriod[1] = 1;
    returnValue.push_back(1);
    for(int prefix = 2; prefix <= n; prefix++)
    {
        if(!hasPeriod(prefix, smallestPeriod[prefix-1]))
            smallestPeriod[prefix] = FindSmallestPeriod(smallestPeriod[prefix-1], prefix, prefix);
        else smallestPeriod[prefix] = smallestPeriod[prefix-1];
        returnValue.push_back(smallestPeriod[prefix]);
    }
    return returnValue;
}
