#include<bits/stdc++.h>
#include "periods.h"
using namespace std;

const int MAXN = 100000;
int minPeriod[MAXN+1];

vector<int> findPeriods(int n)
{
    vector<int> returnValue;
    memset(minPeriod, 0, sizeof(minPeriod));
    minPeriod[1] = 1;
    for(int prefix = 1; prefix <= n; prefix++)
    {
        if(minPeriod[prefix] == 0) minPeriod[prefix] = prefix;
        else continue;
        for(int power = 2; power*prefix <= n; power++)
        {
            if(hasPeriod(power*prefix, minPeriod[prefix]))
                minPeriod[power*prefix] = minPeriod[prefix];
            else break;
        }
        returnValue.push_back(minPeriod[prefix]);
    }
    return returnValue;
}
