#include<bits/stdc++.h>
#include "periods.h"
using namespace std;

const int MAXN = 1e+5+1;
int minPeriod[MAXN], lastIteratedNumber = 2;
bitset<MAXN> iterated;

vector<int> findPeriods(int n)
{
    vector<int> returnValue;
    memset(minPeriod, 0, sizeof(minPeriod));
    minPeriod[1] = 1;
    for(int prefix = 1; prefix <= n; prefix++)
    {
        if(minPeriod[prefix] == 0) minPeriod[prefix] = prefix;
        if(!iterated[prefix])
        {
            for(int power = max(2, (int)((float)lastIteratedNumber/prefix+0.99)); power*prefix <= n; power++)
            {
                if(hasPeriod(power*prefix, minPeriod[prefix]))
                    minPeriod[power*prefix] = minPeriod[prefix];
                else break;
                lastIteratedNumber = power*prefix+1;
            }
        }
        //cout << lastIteratedNumber << endl;
        iterated[minPeriod[prefix]] = true;
        returnValue.push_back(minPeriod[prefix]);
    }
    return returnValue;
}
/*
10
1 2 1 2 1 2 1 2 1 2
*/
