#include <stdio.h>
#include <unordered_map>

#define MAX_X 100001
#define MAX_N 111

int n, q;
std::unordered_map<int, int> cups[MAX_N];

void update(int l, int r, int x) {
	for (int i = l; i <=r; ++i) cups[i][x]++;
}

bool query(int l, int r) {
	for (int i = l + 1; i <= r; ++i)
		if (cups[i] != cups[i - 1]) return false;
	return true;
}

int main() {
	scanf("%d%d", &n, &q);
	for (int i = 0; i < q; ++i) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			int l, r, x;
			l--;
			r--;
			scanf("%d%d%d", &l, &r, &x);
			update(l, r, x);
		} else {
			int l, r;
			l--;
			r--;
			scanf("%d%d", &l, &r);
			printf("%d\n", query(l, r) ? 1 : 0);
		}
	}
}