#include<iostream>
#include<algorithm>
#include "periods.h"
using namespace std;

const int MAXN=1e5;
vector<int> dividers[MAXN+1];

vector<int> findPeriods(int n)
{
    vector<int> v;
    v.push_back(1);

    for(int i=2; i<=n; i++)
    {
        dividers[i].push_back(1);
    }

    for(int i=2; i<=n; i++)
    {
        for(int j=i; j<=n; j+=i)
        {
            dividers[j].push_back(i);
        }

        if(i>6 && v[6]==1)
        {
            v.push_back(1);
            continue;
        }

        int j;
        for(j=0; j<dividers[i].size(); j++)
        {
            if(hasPeriod(i, dividers[i][j]))
            {
                break;
            }
        }

        v.push_back(dividers[i][j]);
    }

    return v;
}
