#include <bits/stdc++.h>
#include "periods.h"

int binsearch(int i, int n, const std::vector<int>& anses)
{
    int l = 1, r = n / i + 1;

    while(l < r - 1)
    {
        int mid = (l + r) / 2;
        if(anses[mid * i] || !hasPeriod(mid * i, i))
        {
            r = mid;
        }else
        {
            l = mid;
        }
    }

    return l;
}

std::vector<int> findPeriods(int n)
{
    std::vector<int> anses(n + 1, 0), ans(n);

    for(int i = 1; i <= n; ++ i)
    {
        if(!anses[i])
        {
            int m = binsearch(i, n, anses);
            //std::cout << m << '\n';
            anses[i] = i;
            for(int j = 2; j <= m; ++ j)
            {
                anses[j * i] = i;
            }
        }
    }

    for(int i = 0; i < n; ++ i)
    {
        ans[i] = anses[i + 1];
    }

    return ans;
}