#include<iostream>
#include<algorithm>
#include<cmath>
#include<string>
#include<vector>
#include<stack>
#include<queue>
#include<cstdio>
#include<iomanip>
#include<cstdlib>
#include<set>
#include<map>
#include<list>
#define MOD 1000000007
using namespace std;
long long n,m,q,k,ans,fl1,br,l1,r1;
struct tel{
    long long h1,h2,h3,h4,h5;
};
tel p,t={0,0,0,0,0};
bool comp(tel c1,tel c2){
    if(c1.h1==c2.h1 && c1.h2==c2.h2 && c1.h3==c2.h3 && c1.h4==c2.h4 && c1.h5==c2.h5)return true;
    return false;
}
struct Node{
    tel h;
    long long l,r,fl;
    Node *ll,*rr;
    Node(){
        h={0,1,0,0,0};
        ll=rr=NULL;
        fl=0;
    }
};
void postr(Node* vr, long long l, long long r){
    vr->l=l; vr->r=r;
    if(l==r)return;
    vr->ll=new Node(); postr(vr->ll,l,(l+r)/2);
    vr->rr=new Node(); postr(vr->rr,(l+r)/2+1,r);
}

void up_hash(tel &c1){
    c1.h1=(c1.h1+k)%MOD;
    c1.h2=(c1.h2*k)%MOD;
    c1.h3=(c1.h3+k*k)%MOD;
    c1.h4=c1.h4^k;
    c1.h5=c1.h5&k;
}

void up_hashHash(tel &c1,tel c2){
    c1.h1=(c1.h1+c2.h1)%MOD;
    c1.h2=(c1.h2*c2.h2)%MOD;
    c1.h3=(c1.h3+c2.h3)%MOD;
    c1.h4=c1.h4^c2.h4;
    c1.h5=c1.h5&k;
}
void up(Node* vr, long long l, long long r){
    if(vr->l==l && vr->r==r){
        up_hash(vr->h);
        //cout<<"!!! "<<vr->l<<" "<<vr->r<<" "<<vr->h.h1<<" "<<vr->h.h2<<" "<<vr->h.h3<<"\n";
        return;
    }
    vr->fl=1;
    if(l<=vr->ll->r) up(vr->ll,l,min(r,vr->ll->r));
    if(r>=vr->rr->l) up(vr->rr,max(l,vr->rr->l),r);
    if(comp(vr->ll->h,vr->rr->h)){
        up_hashHash(vr->h,vr->ll->h);
        if(vr->ll->fl==0 && vr->rr->fl==0)vr->fl=0;
        vr->ll->h=vr->rr->h={0,0,0,0,0};
    }
    //cout<<"! "<<vr->l<<" "<<vr->r<<" "<<vr->h.h1<<" "<<vr->h.h2<<" "<<vr->h.h3<<" "<<vr->fl<<"\n";
}

void rsq(Node* vr, long long l, long long r,tel cr){
    //cout<<vr->l<<" "<<vr->r<<" "<<vr->fl<<"rsq\n";
    up_hashHash(cr,vr->h);
    if(vr->l==l && vr->r==r){
    //cout<<"rsq ! "<<vr->l<<" "<<vr->r<<" "<<vr->h.h1<<" "<<vr->h.h2<<" "<<vr->h.h3<<" "<<vr->fl<<"\n";
        if(vr->fl==1)fl1=1;
        if(br++==0)p=cr;
        else if(!comp(p,cr))fl1=1;
        return;
    }
    if(l<=vr->ll->r) rsq(vr->ll,l,min(r,vr->ll->r),cr);
    if(r>=vr->rr->l) rsq(vr->rr,max(l,vr->rr->l),r,cr);
}

Node *root=new Node();
int main(){
    int i,j;
    cin>>n>>m;
    //cout<<root<<endl;
    postr(root,1,n);
    for(i=1;i<=m;i++){
        scanf("%lld",&q);
        if(q==1){
            scanf("%lld %lld %lld",&l1,&r1,&k);
            up(root,l1,r1);
        }
        else{
            scanf("%lld %lld",&l1,&r1);
            fl1=0; br=0; rsq(root,l1,r1,t);
            if(fl1==0)cout<<"1\n";
            else cout<<"0\n";
        }
        //cout<<endl;
    }

    return 0;
}
/*
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 2


8 50
2 1 3
2 4 7
1 2 4 5
2 1 3
2 2 4
2 2 3
2 3 4
1 4 6 3
2 5 6
2 2 3
2 3 4
2 2 4
2 4 5
2 7 8
1 1 3 3
2 1 5
2 1 1
2 5 6
2 2 5
2 2 4
*/
